# TonysList

A minimalist Craigslist clone for small communities.

## TODO

- Classifieds Features
  - Email subscriptions to a saved query
    - Setup [rebound](https://postmarkapp.com/rebound)
    - Use [message streams](https://postmarkapp.com/message-streams)
- Translations
  - probably using [go-i18n](https://github.com/nicksnyder/go-i18n/)

## Dependencies

These dependencies are installed in the `.devcontainer/Dockerfile` that should
be used for development. When a dockerfile for production is created they will
also have these tools installed.

- libaom-dev
  - Used by [go-avif](https://github.com/Kagami/go-avif) under the hood.
  - See also [libavif](https://github.com/AOMediaCodec/libavif)
- [livbips](https://github.com/jcupitt/libvips)

## Developing

This site was originally bootstrapped by the wonderful [Pagoda starter
kit](https://github.com/mikestefanello/pagoda), however just about everthing has
been changed and very little of Pagoda remains. It leverages the following
projects (not a complete list):

- [Alpine.js](https://alpinejs.dev/): Minimal js frontend framework
  - [Docs](https://alpinejs.dev/start-here)
- [TailwindCSS](https://tailwindcss.com/): CSS framework
  - [Docs](https://tailwindcss.com/docs)
  - [TailwindUI Components](https://tailwindui.com/components)
- [Echo](https://echo.labstack.com/): Web framework
  - [Docs](https://echo.labstack.com/guide/)
- [Postmark](https://postmarkapp.com)
  - [Docs](https://postmarkapp.com/manual)

### Getting Started

Launch the Docker container described in `.devcontainer` and mount this
directory at `/workspaces/tonyslist`. If you are using VS Code, it will probably
offer to do this for you automatically.

You can now start up the web server by running `make`.
