package constants

import "time"

const (
	ClassifiedsDurationDays = 14

	// ClassifiedsDuration is the amount of time after posting that a
	// classifieds post will be displayed before expiring.
	//
	// Note: Also search "-14 days" in the codebase.
	//
	// TODO: This should be in the config.yaml, but I could not find a good way
	// to use it during template rendering to pass into the methods on
	// Publishable.
	ClassifiedsDuration = ClassifiedsDurationDays * 24 * time.Hour

	// AnonymouseEmailPrefix is used to denote that an incoming email is for a
	// classifieds post anonymous email address.
	// NOTE: This prefix is stored in the database, so a migration is needed if
	// this needs to be changed. Ideally it should not be stored in the
	// database, and instead only prepended when displaying the addres.
	AnonymousEmailPrefix = "c-"
	AnonymousEmailLen    = 5

	// MailingListPrefix is used to denote that an incoming email is for a
	// mailing list. It is prepended to the short-code stored in the database
	// with each mailing list.
	MailingListPrefix = "m-"
)
