package constants

// Filter is a section on the sidebar of the post listing pages which allows
// filtering the posts to a subset.
type Filter struct {
	SectionName    string
	SectionDisplay string
	Options        []FilterOption
}

type FilterOption struct {
	Value   string
	Display string
}

// DefaultFilters are the filters used in the sidebar for the different post
// types.
var DefaultFilters = []Filter{
	{
		SectionDisplay: "Filters",
		SectionName:    "basic",
		Options: []FilterOption{
			{
				Value:   "photos",
				Display: "Has Photos",
			},
			{
				Value:   "title-only",
				Display: "Search Title Only",
			},
		},
	},
}
