package constants

import "git.grosinger.net/tgrosinger/tonyslist/constants/pages"

type PostType string

const (
	Classified PostType = pages.Classified
	Housing    PostType = pages.Housing
)

type ClassifiedType string

const (
	ForSale      ClassifiedType = pages.ForSale
	ForFree      ClassifiedType = pages.ForFree
	WantToBuy    ClassifiedType = pages.WantToBuy
	WantToBorrow ClassifiedType = pages.WantToBorrow
)

type HousingType string

const (
	ForRent HousingType = pages.ForRent
	Request HousingType = pages.Request
)

type PostStatus string

const (
	Draft    PostStatus = "draft"
	Active   PostStatus = "active"
	Expired  PostStatus = "expired"
	Unlisted PostStatus = "unlisted"
)

func (ClassifiedType) Values() []string {
	allPostTypes := []ClassifiedType{ForSale, ForFree, WantToBuy, WantToBorrow}
	postTypeStrings := make([]string, 0, len(allPostTypes))
	for _, s := range allPostTypes {
		postTypeStrings = append(postTypeStrings, string(s))
	}
	return postTypeStrings
}
