package constants

// StatName is the "name" column in the "stats" table in the database. The stats
// table stores counters and gauges which need to be persisted across restarts.
// They are then exported to Prometheus/Grafana by a cron job.
type StatName string

const (
	PostDelisted StatName = "post-delisted"
	PostRelisted StatName = "post-relisted"

	ForSaleCreated      StatName = "for-sale-created"
	ForFreeCreated      StatName = "for-free-created"
	WantToBorrowCreated StatName = "want-to-borrow-created"
	WantToBuyCreated    StatName = "want-to-buy-created"
	ForRentCreated      StatName = "for-rent-created"
	RequestCreated      StatName = "request-created"
	EventCreate         StatName = "event-created"
)
