ALTER TABLE mailing_list_messages
DROP COLUMN postmark_message_id;

CREATE TABLE IF NOT EXISTS mailing_list_message_ids (
    -- The Message-ID header in the email
    id text NOT NULL PRIMARY KEY,

    -- Reference to users
    user_id integer NOT NULL,
    
    -- Reference to mailing_list_messages
    message_id integer NOT NULL,

    CONSTRAINT `mailing_list_message_ids_message_id`
        FOREIGN KEY (`message_id`)
        REFERENCES `mailing_list_messages` (`id`)
        ON DELETE CASCADE,
    
    CONSTRAINT `mailing_list_message_ids_user_id`
        FOREIGN KEY (`user_id`)
        REFERENCES `users` (`id`)
        ON DELETE CASCADE
);