CREATE TABLE housing (
    id integer NOT NULL PRIMARY KEY,
    housing_type text NOT NULL,
    rent real,
    bedrooms integer,
    bathrooms real,
    parking_spots integer,
    pets bool NOT NULL DEFAULT false,
    shared bool NOT NULL DEFAULT false,
    street text,
    zipcode text,
    map_filename text,

    CONSTRAINT `housing_for_rent_posts_base`
        FOREIGN KEY (`id`)
        REFERENCES `posts_base` (`id`)
        ON DELETE CASCADE
);

INSERT INTO housing
    (id, housing_type, rent, bedrooms, bathrooms, parking_spots, pets, shared, street, zipcode, map_filename)
SELECT
    fr.id, 'for-rent', fr.rent, fr.bedrooms, fr.bathrooms, fr.parking_spots, fr.pets, fr.shared, fr.street, fr.zipcode, fr.map_filename
FROM housing_for_rent fr;

INSERT INTO housing
    (id, housing_type, bedrooms, bathrooms, parking_spots, pets, shared)
SELECT r.id, 'request', r.bedrooms, r.bathrooms, r.parking_spots, r.pets, r.shared
FROM housing_requests r;

DROP TABLE housing_requests;
DROP TABLE housing_for_rent;

UPDATE posts_base SET post_type = 'housing' WHERE post_type in ('for-rent', 'request');
