-- name: GetClassifiedPost :one
SELECT * FROM classifieds
WHERE id = ?
LIMIT 1;

-- name: GetNextActivePost :one
SELECT sqlc.embed(c), sqlc.embed(pb)
FROM classifieds c
JOIN posts_base pb ON c.id = pb.id
WHERE
    moderator_delisted = false
    AND listed = true
    AND datetime(published_at) > datetime('now', '-14 days')
    AND pb.id > ?
ORDER BY pb.id ASC
LIMIT 1;

-- name: GetMyClassifiedPostIDs :many
SELECT pb.*
FROM posts_base pb
JOIN classifieds c ON c.id = pb.id
WHERE
    creator = ?
    AND post_type = ?
    AND classified_type = ?
    AND moderator_delisted = false;

-- name: GetActiveClassifiedPostsCount :many
SELECT COUNT(*), classified_type FROM posts_base pb
JOIN classifieds c on c.id = pb.id
WHERE moderator_delisted = false
    AND listed = true
    AND datetime(published_at) > datetime('now', '-14 days')
GROUP BY classified_type;

-- name: CreateClassifiedPost :execlastid
INSERT INTO classifieds (
    id, classified_type, price
) VALUES (
    ?, ?, ?
);

-- name: UpdateClassifiedPost :exec
UPDATE classifieds
SET price = ?
WHERE id = ?;
