-- name: GetHousingPost :one
SELECT * FROM housing
WHERE id = ?
LIMIT 1;

-- name: GetActiveHousingPostsCount :one
SELECT COUNT(*) FROM posts_base pb
WHERE moderator_delisted = false
    AND listed = true
    AND datetime(published_at) > datetime('now', '-14 days')
    AND post_type = 'housing';

-- name: GetMyHousingPostIDs :many
SELECT pb.*
FROM posts_base pb
JOIN housing h ON h.id = pb.id
WHERE
    creator = ?
    AND post_type = ?
    AND housing_type = ?
    AND moderator_delisted = false;

-- name: CreateHousingPost :exec
INSERT INTO housing(
    id, housing_type, rent, street, zipcode, pets, shared, bathrooms, bedrooms, parking_spots
) VALUES (
    ?, ?, ?, ?, ?, ?, ?, ?, ?, ?
);

-- name: UpdateHousingPost :exec
UPDATE housing
SET
    rent = ?,
    street = ?,
    zipcode = ?,
    pets = ?,
    shared = ?,
    bathrooms = ?,
    bedrooms = ?,
    parking_spots = ?
WHERE id = ?;