-- name: GetPhoto :one
SELECT * FROM photos
WHERE id = ?
LIMIT 1;

-- name: GetPhotos :many
SELECT * FROM photos
WHERE post_id = ?
ORDER BY is_map ASC, id ASC;

-- name: GetPhotosByID :many
SELECT * FROM photos
WHERE id in (sqlc.slice('ids'));

-- name: CreatePhoto :execlastid
-- Create is used to create a photo initially before conversion.
INSERT INTO photos (
    post_id, original_filename, created_at
) VALUES (
    ?, ?, datetime('now')
);

-- name: CreateHousingMap :exec
-- CreateHousingMap is used to directly insert a housing map photo into the database.
INSERT INTO photos (
    post_id, created_at, is_map, fullsize_jpg, alternative_ext
) VALUES (
    ?, datetime('now'), true, ?, ?
);

-- name: ClearPhotoFilename :exec
UPDATE photos
SET original_filename = null
WHERE id = ?;

-- name: SetPhotoFullsize :exec
UPDATE photos
SET
    fullsize_jpg = ?
WHERE id = ?;

-- name: SetPhotoThumbnail :exec
UPDATE photos
SET
    thumbnail_jpg = ?
WHERE id = ?;

-- name: SetPhotoPreview :exec
UPDATE photos
SET
    preview_jpg = ?
WHERE id = ?;

-- name: DeletePhoto :exec
DELETE FROM photos
WHERE id = ?
    AND post_id = ?;
