-- name: GetUserEmailTwiceWeeklyDigestSubscription :many
-- GetUserEmailTwiceWeeklyDigestSubscription retrives user emails that are
-- subscribed to the digest emails. If the user has no subscription specified
-- the settings table then they are subscribed by default.
SELECT u.id, u.email FROM users u 
LEFT JOIN user_settings us on us.user_id = u.id
WHERE 
    (us.key = 'email_digest_subscription' and us.value = 'twice-weekly-digest')
    OR us.key is null;

-- name: GetUserSetting :one
SELECT value FROM user_settings
WHERE user_id = ? AND key = ?;

-- name: SetUserSetting :exec
INSERT INTO user_settings (
    user_id, key, value
) VALUES (
    ?, ?, ?
) ON CONFLICT(user_id, key)
    DO UPDATE SET value = excluded.value;
