package controller

func NewRecoverableError(msg string) error {
	return RecoverableError{
		msg: msg,
	}
}

// RecoverableError is an error type which indicates that the response to the
// user should not be a 5xx, but instead that a message has been created on the
// context and the user should be served the relevant Get handler.
type RecoverableError struct {
	msg string
}

func (e RecoverableError) Error() string {
	return e.msg
}
