package cron

import (
	"os"
	"testing"

	"go.uber.org/zap"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/models"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/models/sqlc"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/services"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/tests"
)

var (
	usr    sqlc.User
	db     *models.Client
	logger *zap.Logger
	c      *services.Container
)

func TestMain(m *testing.M) {
	logger, _ = zap.NewDevelopment()

	configPath := tests.LoadConfigPath()
	logger, err := zap.NewDevelopment()
	if err != nil {
		panic(err)
	}

	c = services.NewContainer(configPath, logger)
	db = c.DB

	// Create a test user
	if usr, err = db.User.CreateMockUser(); err != nil {
		panic(err)
	}

	// Run tests
	exitVal := m.Run()

	// Shutdown the database
	if err = db.Close(); err != nil {
		panic(err)
	}

	os.Exit(exitVal)
}
