package metrics

import (
	"git.grosinger.net/tgrosinger/tonyslist/config"
	"github.com/prometheus/client_golang/prometheus"
	"github.com/prometheus/client_golang/prometheus/promauto"
)

var LabelPostType = "post_type"

var (
	UserCount         prometheus.Gauge
	ActiveClassifieds prometheus.GaugeVec
	ActiveHousing     prometheus.GaugeVec
)

func initializeCronMetrics(cfg *config.Config) {
	UserCount = promauto.NewGauge(prometheus.GaugeOpts{
		Namespace: cfg.App.Name,
		Subsystem: "cron",
		Name:      "user_count",
		Help:      "Number of users registered",
	})
	ActiveClassifieds = *promauto.NewGaugeVec(prometheus.GaugeOpts{
		Namespace: cfg.App.Name,
		Subsystem: "cron",
		Name:      "active_posts_classified",
		Help:      "Number of active posts in the classifieds section",
	}, []string{LabelPostType})
	ActiveHousing = *promauto.NewGaugeVec(prometheus.GaugeOpts{
		Namespace: cfg.App.Name,
		Subsystem: "cron",
		Name:      "active_posts_housing",
		Help:      "Number of active posts in the housing section",
	}, []string{LabelPostType})
}
