package metrics

import (
	"github.com/prometheus/client_golang/prometheus"
	"github.com/prometheus/client_golang/prometheus/promauto"

	"git.grosinger.net/tgrosinger/tonyslist/config"
)

var MailSendFailureCount prometheus.Counter

func initializeMailMetrics(cfg *config.Config) {
	MailSendFailureCount = promauto.NewCounter(
		prometheus.CounterOpts{
			Namespace: cfg.App.Name,
			Subsystem: "mail",
			Name:      "send_err_count",
			Help:      "Number of errors while sending emails",
		},
	)
	MailSendFailureCount.Add(0)
}
