package metrics

import (
	"git.grosinger.net/tgrosinger/tonyslist/config"
	"github.com/prometheus/client_golang/prometheus"
	"github.com/prometheus/client_golang/prometheus/promauto"
)

var (
	PhotoUploadCount        prometheus.Counter
	PhotoUploadFailureCount prometheus.Counter
)

func initializePostsMetrics(cfg *config.Config) {
	PhotoUploadCount = promauto.NewCounter(
		prometheus.CounterOpts{
			Namespace: cfg.App.Name,
			Subsystem: "posts",
			Name:      "photo_upload_count",
			Help:      "Number of photos uploaded for posts",
		},
	)
	PhotoUploadCount.Add(0)

	PhotoUploadFailureCount = promauto.NewCounter(
		prometheus.CounterOpts{
			Namespace: cfg.App.Name,
			Subsystem: "posts",
			Name:      "photo_upload_failure_count",
			Help:      "Number of failures while uploading photos for posts",
		},
	)
	PhotoUploadFailureCount.Add(0)
}
