package metrics

import (
	"github.com/prometheus/client_golang/prometheus"
	"github.com/prometheus/client_golang/prometheus/promauto"

	"git.grosinger.net/tgrosinger/tonyslist/config"
)

var (
	StatsGauge *prometheus.GaugeVec

	LabelName = "name"
)

func initializeStatsMetrics(cfg *config.Config) {
	StatsGauge = promauto.NewGaugeVec(
		prometheus.GaugeOpts{
			Namespace: cfg.App.Name,
			Subsystem: "stats",
			Name:      "values",
			Help:      "Values of the various stats stored in the database",
		},
		[]string{LabelName},
	)
}
