package middleware

import (
	"testing"

	"github.com/labstack/echo/v4"
	"github.com/stretchr/testify/require"
	"go.uber.org/zap"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/context"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/tests"
)

func TestLogRequestResponse(t *testing.T) {
	logger := zap.NewNop()

	ctx, _ := tests.NewContext(c.Web, "/test")
	mw := LogRequestResponse(logger)

	nextCalled := false
	err := mw(func(c echo.Context) error {
		nextCalled = true

		innerLogger := context.GetLogger(c)
		require.Equal(t, logger, innerLogger)

		return nil
	})(ctx)
	require.NoError(t, err)
	require.True(t, nextCalled)
}
