package middleware

import (
	"os"
	"testing"

	"go.uber.org/zap"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/models/sqlc"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/services"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/tests"
)

var (
	c   *services.Container
	usr sqlc.User
)

func TestMain(m *testing.M) {
	// Create a new container
	configPath := tests.LoadConfigPath()
	c = services.NewContainer(configPath, zap.NewNop())

	// Create a user
	var err error
	if usr, err = c.DB.User.CreateMockUser(); err != nil {
		panic(err)
	}

	// Run tests
	exitVal := m.Run()

	// Shutdown the container
	if err = c.Shutdown(); err != nil {
		panic(err)
	}

	os.Exit(exitVal)
}
