package errors

import (
	"net/http"

	"github.com/labstack/echo/v4"
)

var (
	ErrNotFound            = echo.NewHTTPError(http.StatusNotFound, "Unable to find the requested item")
	ErrDuplicateConstraint = echo.NewHTTPError(http.StatusBadRequest, "This resource already exists")

	ErrEmptyQuery             = echo.NewHTTPError(http.StatusInternalServerError, "Query was unexpectedly empty")
	ErrInvalidQueryExclustion = echo.NewHTTPError(http.StatusBadRequest, "Invalid placement of an exclusion parameter in the search query")
)
