package models

import (
	"context"
	"database/sql"
)

type GroupClient struct {
	dbConfig
}

func (c *GroupClient) CreateIfNotExists(ctx context.Context, name string) (int, error) {
	g, err := c.parent.C.GetGroupByName(ctx, name)
	if err == nil {
		return g.ID, nil
	} else if err != sql.ErrNoRows {
		return -1, err
	}

	id, err := c.parent.C.CreateGroup(ctx, name)
	return int(id), err
}
