package housing

import (
	"database/sql"

	"git.grosinger.net/tgrosinger/tonyslist/constants"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/conv"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/models/postbase"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/models/sqlc"
)

type EditableFields struct {
	Bedrooms     conv.NullInt    `db:"bedrooms"`
	Bathrooms    sql.NullFloat64 `db:"bathrooms"`
	ParkingSpots conv.NullInt    `db:"parking_spots"`
	Pets         bool            `db:"pets"`
	Shared       bool            `db:"shared"`
	Rent         sql.NullFloat64 `db:"rent"`
	Street       sql.NullString  `db:"street"`
	Zipcode      sql.NullString  `db:"zipcode"`
}

type Post struct {
	*postbase.PostBase
	EditableFields
	MapFilename sql.NullString `db:"map_filename"`
}

type NewPostInput struct {
	sqlc.CreatePostParams
	EditableFields
	HousingType constants.HousingType
}

type UpdatePostInput struct {
	sqlc.UpdatePostParams
	EditableFields
}
