package postbase

import (
	"git.grosinger.net/tgrosinger/tonyslist/pkg/parser"
)

type SortDir string

const (
	SortDesc SortDir = "DESC"
	SortAsc  SortDir = "ASC"
)

type Sortable struct {
	SortColumn string
	SortDir    SortDir
}

type SearchQuery struct {
	Query         string
	ParsedQuery   *parser.SearchQuery
	RequirePhotos bool
	Fields        []string
}

type Pagination struct {
	Limit  uint64
	Offset uint64
}

type SelectInput struct {
	SearchQuery
	Pagination
	Sortable
	IncludeUnlisted bool
}

type QueryBuilder struct {
	Columns []string
	Values  []interface{}
	// TODO: Implement this for one type to test the idea, then write unit tests
}

func (b *QueryBuilder) Add(column string, value interface{}) {
	b.Columns = append(b.Columns, column)
	b.Values = append(b.Values, value)
}
