// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.27.0
// source: classifieds.sql

package sqlc

import (
	"context"
	"database/sql"

	"git.grosinger.net/tgrosinger/tonyslist/constants"
)

const createClassifiedPost = `-- name: CreateClassifiedPost :execlastid
INSERT INTO classifieds (
    id, classified_type, price
) VALUES (
    ?, ?, ?
)
`

type CreateClassifiedPostParams struct {
	ID             int                      `db:"id"`
	ClassifiedType constants.ClassifiedType `db:"classified_type"`
	Price          sql.NullFloat64          `db:"price"`
}

func (q *Queries) CreateClassifiedPost(ctx context.Context, arg CreateClassifiedPostParams) (int64, error) {
	result, err := q.db.ExecContext(ctx, createClassifiedPost, arg.ID, arg.ClassifiedType, arg.Price)
	if err != nil {
		return 0, err
	}
	return result.LastInsertId()
}

const getActiveClassifiedPostsCount = `-- name: GetActiveClassifiedPostsCount :many
SELECT COUNT(*), classified_type FROM posts_base pb
JOIN classifieds c on c.id = pb.id
WHERE moderator_delisted = false
    AND listed = true
    AND datetime(published_at) > datetime('now', '-14 days')
GROUP BY classified_type
`

type GetActiveClassifiedPostsCountRow struct {
	Count          int                      `db:"count"`
	ClassifiedType constants.ClassifiedType `db:"classified_type"`
}

func (q *Queries) GetActiveClassifiedPostsCount(ctx context.Context) ([]GetActiveClassifiedPostsCountRow, error) {
	rows, err := q.db.QueryContext(ctx, getActiveClassifiedPostsCount)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []GetActiveClassifiedPostsCountRow
	for rows.Next() {
		var i GetActiveClassifiedPostsCountRow
		if err := rows.Scan(&i.Count, &i.ClassifiedType); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getClassifiedPost = `-- name: GetClassifiedPost :one
SELECT id, classified_type, price FROM classifieds
WHERE id = ?
LIMIT 1
`

func (q *Queries) GetClassifiedPost(ctx context.Context, id int) (Classified, error) {
	row := q.db.QueryRowContext(ctx, getClassifiedPost, id)
	var i Classified
	err := row.Scan(&i.ID, &i.ClassifiedType, &i.Price)
	return i, err
}

const getMyClassifiedPostIDs = `-- name: GetMyClassifiedPostIDs :many
SELECT pb.id, pb.post_type, pb.title, pb.description, pb.phone_call, pb.phone_text, pb.featured_photo, pb.creator, pb.created_at, pb.published_at, pb.listed, pb.moderator_delisted, pb.anonymous_email, pb.count_times_posted, pb.count_email_responses, pb.count_nonowner_views
FROM posts_base pb
JOIN classifieds c ON c.id = pb.id
WHERE
    creator = ?
    AND post_type = ?
    AND classified_type = ?
    AND moderator_delisted = false
`

type GetMyClassifiedPostIDsParams struct {
	Creator        int                      `db:"creator"`
	PostType       constants.PostType       `db:"post_type"`
	ClassifiedType constants.ClassifiedType `db:"classified_type"`
}

func (q *Queries) GetMyClassifiedPostIDs(ctx context.Context, arg GetMyClassifiedPostIDsParams) ([]PostsBase, error) {
	rows, err := q.db.QueryContext(ctx, getMyClassifiedPostIDs, arg.Creator, arg.PostType, arg.ClassifiedType)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []PostsBase
	for rows.Next() {
		var i PostsBase
		if err := rows.Scan(
			&i.ID,
			&i.PostType,
			&i.Title,
			&i.Description,
			&i.PhoneCall,
			&i.PhoneText,
			&i.FeaturedPhoto,
			&i.Creator,
			&i.CreatedAt,
			&i.PublishedAt,
			&i.Listed,
			&i.ModeratorDelisted,
			&i.AnonymousEmail,
			&i.CountTimesPosted,
			&i.CountEmailResponses,
			&i.CountNonownerViews,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getNextActivePost = `-- name: GetNextActivePost :one
SELECT c.id, c.classified_type, c.price, pb.id, pb.post_type, pb.title, pb.description, pb.phone_call, pb.phone_text, pb.featured_photo, pb.creator, pb.created_at, pb.published_at, pb.listed, pb.moderator_delisted, pb.anonymous_email, pb.count_times_posted, pb.count_email_responses, pb.count_nonowner_views
FROM classifieds c
JOIN posts_base pb ON c.id = pb.id
WHERE
    moderator_delisted = false
    AND listed = true
    AND datetime(published_at) > datetime('now', '-14 days')
    AND pb.id > ?
ORDER BY pb.id ASC
LIMIT 1
`

type GetNextActivePostRow struct {
	Classified Classified `db:"classified"`
	PostsBase  PostsBase  `db:"posts_base"`
}

func (q *Queries) GetNextActivePost(ctx context.Context, id int) (GetNextActivePostRow, error) {
	row := q.db.QueryRowContext(ctx, getNextActivePost, id)
	var i GetNextActivePostRow
	err := row.Scan(
		&i.Classified.ID,
		&i.Classified.ClassifiedType,
		&i.Classified.Price,
		&i.PostsBase.ID,
		&i.PostsBase.PostType,
		&i.PostsBase.Title,
		&i.PostsBase.Description,
		&i.PostsBase.PhoneCall,
		&i.PostsBase.PhoneText,
		&i.PostsBase.FeaturedPhoto,
		&i.PostsBase.Creator,
		&i.PostsBase.CreatedAt,
		&i.PostsBase.PublishedAt,
		&i.PostsBase.Listed,
		&i.PostsBase.ModeratorDelisted,
		&i.PostsBase.AnonymousEmail,
		&i.PostsBase.CountTimesPosted,
		&i.PostsBase.CountEmailResponses,
		&i.PostsBase.CountNonownerViews,
	)
	return i, err
}

const updateClassifiedPost = `-- name: UpdateClassifiedPost :exec
UPDATE classifieds
SET price = ?
WHERE id = ?
`

type UpdateClassifiedPostParams struct {
	Price sql.NullFloat64 `db:"price"`
	ID    int             `db:"id"`
}

func (q *Queries) UpdateClassifiedPost(ctx context.Context, arg UpdateClassifiedPostParams) error {
	_, err := q.db.ExecContext(ctx, updateClassifiedPost, arg.Price, arg.ID)
	return err
}
