// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.27.0
// source: housing.sql

package sqlc

import (
	"context"
	"database/sql"

	"git.grosinger.net/tgrosinger/tonyslist/constants"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/conv"
)

const createHousingPost = `-- name: CreateHousingPost :exec
INSERT INTO housing(
    id, housing_type, rent, street, zipcode, pets, shared, bathrooms, bedrooms, parking_spots
) VALUES (
    ?, ?, ?, ?, ?, ?, ?, ?, ?, ?
)
`

type CreateHousingPostParams struct {
	ID           int                   `db:"id"`
	HousingType  constants.HousingType `db:"housing_type"`
	Rent         sql.NullFloat64       `db:"rent"`
	Street       sql.NullString        `db:"street"`
	Zipcode      sql.NullString        `db:"zipcode"`
	Pets         bool                  `db:"pets"`
	Shared       bool                  `db:"shared"`
	Bathrooms    sql.NullFloat64       `db:"bathrooms"`
	Bedrooms     conv.NullInt          `db:"bedrooms"`
	ParkingSpots conv.NullInt          `db:"parking_spots"`
}

func (q *Queries) CreateHousingPost(ctx context.Context, arg CreateHousingPostParams) error {
	_, err := q.db.ExecContext(ctx, createHousingPost,
		arg.ID,
		arg.HousingType,
		arg.Rent,
		arg.Street,
		arg.Zipcode,
		arg.Pets,
		arg.Shared,
		arg.Bathrooms,
		arg.Bedrooms,
		arg.ParkingSpots,
	)
	return err
}

const getActiveHousingPostsCount = `-- name: GetActiveHousingPostsCount :one
SELECT COUNT(*) FROM posts_base pb
WHERE moderator_delisted = false
    AND listed = true
    AND datetime(published_at) > datetime('now', '-14 days')
    AND post_type = 'housing'
`

func (q *Queries) GetActiveHousingPostsCount(ctx context.Context) (int, error) {
	row := q.db.QueryRowContext(ctx, getActiveHousingPostsCount)
	var count int
	err := row.Scan(&count)
	return count, err
}

const getHousingPost = `-- name: GetHousingPost :one
SELECT id, housing_type, rent, bedrooms, bathrooms, parking_spots, pets, shared, street, zipcode FROM housing
WHERE id = ?
LIMIT 1
`

func (q *Queries) GetHousingPost(ctx context.Context, id int) (Housing, error) {
	row := q.db.QueryRowContext(ctx, getHousingPost, id)
	var i Housing
	err := row.Scan(
		&i.ID,
		&i.HousingType,
		&i.Rent,
		&i.Bedrooms,
		&i.Bathrooms,
		&i.ParkingSpots,
		&i.Pets,
		&i.Shared,
		&i.Street,
		&i.Zipcode,
	)
	return i, err
}

const getMyHousingPostIDs = `-- name: GetMyHousingPostIDs :many
SELECT pb.id, pb.post_type, pb.title, pb.description, pb.phone_call, pb.phone_text, pb.featured_photo, pb.creator, pb.created_at, pb.published_at, pb.listed, pb.moderator_delisted, pb.anonymous_email, pb.count_times_posted, pb.count_email_responses, pb.count_nonowner_views
FROM posts_base pb
JOIN housing h ON h.id = pb.id
WHERE
    creator = ?
    AND post_type = ?
    AND housing_type = ?
    AND moderator_delisted = false
`

type GetMyHousingPostIDsParams struct {
	Creator     int                   `db:"creator"`
	PostType    constants.PostType    `db:"post_type"`
	HousingType constants.HousingType `db:"housing_type"`
}

func (q *Queries) GetMyHousingPostIDs(ctx context.Context, arg GetMyHousingPostIDsParams) ([]PostsBase, error) {
	rows, err := q.db.QueryContext(ctx, getMyHousingPostIDs, arg.Creator, arg.PostType, arg.HousingType)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []PostsBase
	for rows.Next() {
		var i PostsBase
		if err := rows.Scan(
			&i.ID,
			&i.PostType,
			&i.Title,
			&i.Description,
			&i.PhoneCall,
			&i.PhoneText,
			&i.FeaturedPhoto,
			&i.Creator,
			&i.CreatedAt,
			&i.PublishedAt,
			&i.Listed,
			&i.ModeratorDelisted,
			&i.AnonymousEmail,
			&i.CountTimesPosted,
			&i.CountEmailResponses,
			&i.CountNonownerViews,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updateHousingPost = `-- name: UpdateHousingPost :exec
UPDATE housing
SET
    rent = ?,
    street = ?,
    zipcode = ?,
    pets = ?,
    shared = ?,
    bathrooms = ?,
    bedrooms = ?,
    parking_spots = ?
WHERE id = ?
`

type UpdateHousingPostParams struct {
	Rent         sql.NullFloat64 `db:"rent"`
	Street       sql.NullString  `db:"street"`
	Zipcode      sql.NullString  `db:"zipcode"`
	Pets         bool            `db:"pets"`
	Shared       bool            `db:"shared"`
	Bathrooms    sql.NullFloat64 `db:"bathrooms"`
	Bedrooms     conv.NullInt    `db:"bedrooms"`
	ParkingSpots conv.NullInt    `db:"parking_spots"`
	ID           int             `db:"id"`
}

func (q *Queries) UpdateHousingPost(ctx context.Context, arg UpdateHousingPostParams) error {
	_, err := q.db.ExecContext(ctx, updateHousingPost,
		arg.Rent,
		arg.Street,
		arg.Zipcode,
		arg.Pets,
		arg.Shared,
		arg.Bathrooms,
		arg.Bedrooms,
		arg.ParkingSpots,
		arg.ID,
	)
	return err
}
