// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.27.0

package sqlc

import (
	"database/sql"
	"time"

	"git.grosinger.net/tgrosinger/tonyslist/constants"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/conv"
)

type Classified struct {
	ID             int                      `db:"id"`
	ClassifiedType constants.ClassifiedType `db:"classified_type"`
	Price          sql.NullFloat64          `db:"price"`
}

type CronLastRun struct {
	Name    string    `db:"name"`
	LastRun time.Time `db:"last_run"`
}

type Event struct {
	ID          int          `db:"id"`
	Title       string       `db:"title"`
	Description string       `db:"description"`
	Creator     int          `db:"creator"`
	CreatedAt   time.Time    `db:"created_at"`
	Location    string       `db:"location"`
	HasTime     bool         `db:"has_time"`
	StartTime   time.Time    `db:"start_time"`
	EndTime     sql.NullTime `db:"end_time"`
}

type EventPhoto struct {
	ID         int       `db:"id"`
	EventID    int       `db:"event_id"`
	CreatedAt  time.Time `db:"created_at"`
	PreviewJpg []byte    `db:"preview_jpg"`
}

type Group struct {
	ID   int    `db:"id"`
	Name string `db:"name"`
}

type Housing struct {
	ID           int                   `db:"id"`
	HousingType  constants.HousingType `db:"housing_type"`
	Rent         sql.NullFloat64       `db:"rent"`
	Bedrooms     conv.NullInt          `db:"bedrooms"`
	Bathrooms    sql.NullFloat64       `db:"bathrooms"`
	ParkingSpots conv.NullInt          `db:"parking_spots"`
	Pets         bool                  `db:"pets"`
	Shared       bool                  `db:"shared"`
	Street       sql.NullString        `db:"street"`
	Zipcode      sql.NullString        `db:"zipcode"`
}

type Photo struct {
	ID               int            `db:"id"`
	CreatedAt        time.Time      `db:"created_at"`
	PostID           int            `db:"post_id"`
	PreviewJpg       []byte         `db:"preview_jpg"`
	ThumbnailJpg     []byte         `db:"thumbnail_jpg"`
	FullsizeJpg      []byte         `db:"fullsize_jpg"`
	IsMap            bool           `db:"is_map"`
	OriginalFilename sql.NullString `db:"original_filename"`
	AlternativeExt   sql.NullString `db:"alternative_ext"`
}

type PostsBase struct {
	ID                  int                `db:"id"`
	PostType            constants.PostType `db:"post_type"`
	Title               string             `db:"title"`
	Description         string             `db:"description"`
	PhoneCall           sql.NullString     `db:"phone_call"`
	PhoneText           sql.NullString     `db:"phone_text"`
	FeaturedPhoto       conv.NullInt       `db:"featured_photo"`
	Creator             int                `db:"creator"`
	CreatedAt           time.Time          `db:"created_at"`
	PublishedAt         sql.NullTime       `db:"published_at"`
	Listed              bool               `db:"listed"`
	ModeratorDelisted   bool               `db:"moderator_delisted"`
	AnonymousEmail      sql.NullString     `db:"anonymous_email"`
	CountTimesPosted    int                `db:"count_times_posted"`
	CountEmailResponses int                `db:"count_email_responses"`
	CountNonownerViews  int                `db:"count_nonowner_views"`
}

type PostsBaseFt struct {
	Title       string `db:"title"`
	Description string `db:"description"`
}

type Stat struct {
	ID    int                `db:"id"`
	Name  constants.StatName `db:"name"`
	Value int                `db:"value"`
}

type User struct {
	ID                       int            `db:"id"`
	Email                    string         `db:"email"`
	Verified                 bool           `db:"verified"`
	CreatedAt                time.Time      `db:"created_at"`
	Name                     sql.NullString `db:"name"`
	StripeCustomerID         sql.NullString `db:"stripe_customer_id"`
	CountPostsCreated        int            `db:"count_posts_created"`
	CountEventsCreated       int            `db:"count_events_created"`
	CountLogins              int            `db:"count_logins"`
	CountPageLoads           int            `db:"count_page_loads"`
	LastLogin                sql.NullTime   `db:"last_login"`
	CountBouncedEmails       int            `db:"count_bounced_emails"`
	CountPostsResponseEmails int            `db:"count_posts_response_emails"`
	CountOtherIncomingEmail  int            `db:"count_other_incoming_email"`
	DigestMarkedSpam         bool           `db:"digest_marked_spam"`
	AdminMarkedSpam          bool           `db:"admin_marked_spam"`
	UserMessageMarkedSpam    bool           `db:"user_message_marked_spam"`
	Username                 sql.NullString `db:"username"`
}

type UserGroup struct {
	UserID  int `db:"user_id"`
	GroupID int `db:"group_id"`
}

type UserSetting struct {
	UserID int            `db:"user_id"`
	Key    string         `db:"key"`
	Value  sql.NullString `db:"value"`
}
