// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.27.0
// source: photos.sql

package sqlc

import (
	"context"
	"database/sql"
	"strings"
)

const clearPhotoFilename = `-- name: ClearPhotoFilename :exec
UPDATE photos
SET original_filename = null
WHERE id = ?
`

func (q *Queries) ClearPhotoFilename(ctx context.Context, id int) error {
	_, err := q.db.ExecContext(ctx, clearPhotoFilename, id)
	return err
}

const createHousingMap = `-- name: CreateHousingMap :exec
INSERT INTO photos (
    post_id, created_at, is_map, fullsize_jpg, alternative_ext
) VALUES (
    ?, datetime('now'), true, ?, ?
)
`

type CreateHousingMapParams struct {
	PostID         int            `db:"post_id"`
	FullsizeJpg    []byte         `db:"fullsize_jpg"`
	AlternativeExt sql.NullString `db:"alternative_ext"`
}

// CreateHousingMap is used to directly insert a housing map photo into the database.
func (q *Queries) CreateHousingMap(ctx context.Context, arg CreateHousingMapParams) error {
	_, err := q.db.ExecContext(ctx, createHousingMap, arg.PostID, arg.FullsizeJpg, arg.AlternativeExt)
	return err
}

const createPhoto = `-- name: CreatePhoto :execlastid
INSERT INTO photos (
    post_id, original_filename, created_at
) VALUES (
    ?, ?, datetime('now')
)
`

type CreatePhotoParams struct {
	PostID           int            `db:"post_id"`
	OriginalFilename sql.NullString `db:"original_filename"`
}

// Create is used to create a photo initially before conversion.
func (q *Queries) CreatePhoto(ctx context.Context, arg CreatePhotoParams) (int64, error) {
	result, err := q.db.ExecContext(ctx, createPhoto, arg.PostID, arg.OriginalFilename)
	if err != nil {
		return 0, err
	}
	return result.LastInsertId()
}

const deletePhoto = `-- name: DeletePhoto :exec
DELETE FROM photos
WHERE id = ?
    AND post_id = ?
`

type DeletePhotoParams struct {
	ID     int `db:"id"`
	PostID int `db:"post_id"`
}

func (q *Queries) DeletePhoto(ctx context.Context, arg DeletePhotoParams) error {
	_, err := q.db.ExecContext(ctx, deletePhoto, arg.ID, arg.PostID)
	return err
}

const getPhoto = `-- name: GetPhoto :one
SELECT id, created_at, post_id, preview_jpg, thumbnail_jpg, fullsize_jpg, is_map, original_filename, alternative_ext FROM photos
WHERE id = ?
LIMIT 1
`

func (q *Queries) GetPhoto(ctx context.Context, id int) (Photo, error) {
	row := q.db.QueryRowContext(ctx, getPhoto, id)
	var i Photo
	err := row.Scan(
		&i.ID,
		&i.CreatedAt,
		&i.PostID,
		&i.PreviewJpg,
		&i.ThumbnailJpg,
		&i.FullsizeJpg,
		&i.IsMap,
		&i.OriginalFilename,
		&i.AlternativeExt,
	)
	return i, err
}

const getPhotos = `-- name: GetPhotos :many
SELECT id, created_at, post_id, preview_jpg, thumbnail_jpg, fullsize_jpg, is_map, original_filename, alternative_ext FROM photos
WHERE post_id = ?
ORDER BY is_map ASC, id ASC
`

func (q *Queries) GetPhotos(ctx context.Context, postID int) ([]Photo, error) {
	rows, err := q.db.QueryContext(ctx, getPhotos, postID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Photo
	for rows.Next() {
		var i Photo
		if err := rows.Scan(
			&i.ID,
			&i.CreatedAt,
			&i.PostID,
			&i.PreviewJpg,
			&i.ThumbnailJpg,
			&i.FullsizeJpg,
			&i.IsMap,
			&i.OriginalFilename,
			&i.AlternativeExt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getPhotosByID = `-- name: GetPhotosByID :many
SELECT id, created_at, post_id, preview_jpg, thumbnail_jpg, fullsize_jpg, is_map, original_filename, alternative_ext FROM photos
WHERE id in (/*SLICE:ids*/?)
`

func (q *Queries) GetPhotosByID(ctx context.Context, ids []int) ([]Photo, error) {
	query := getPhotosByID
	var queryParams []interface{}
	if len(ids) > 0 {
		for _, v := range ids {
			queryParams = append(queryParams, v)
		}
		query = strings.Replace(query, "/*SLICE:ids*/?", strings.Repeat(",?", len(ids))[1:], 1)
	} else {
		query = strings.Replace(query, "/*SLICE:ids*/?", "NULL", 1)
	}
	rows, err := q.db.QueryContext(ctx, query, queryParams...)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Photo
	for rows.Next() {
		var i Photo
		if err := rows.Scan(
			&i.ID,
			&i.CreatedAt,
			&i.PostID,
			&i.PreviewJpg,
			&i.ThumbnailJpg,
			&i.FullsizeJpg,
			&i.IsMap,
			&i.OriginalFilename,
			&i.AlternativeExt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const setPhotoFullsize = `-- name: SetPhotoFullsize :exec
UPDATE photos
SET
    fullsize_jpg = ?
WHERE id = ?
`

type SetPhotoFullsizeParams struct {
	FullsizeJpg []byte `db:"fullsize_jpg"`
	ID          int    `db:"id"`
}

func (q *Queries) SetPhotoFullsize(ctx context.Context, arg SetPhotoFullsizeParams) error {
	_, err := q.db.ExecContext(ctx, setPhotoFullsize, arg.FullsizeJpg, arg.ID)
	return err
}

const setPhotoPreview = `-- name: SetPhotoPreview :exec
UPDATE photos
SET
    preview_jpg = ?
WHERE id = ?
`

type SetPhotoPreviewParams struct {
	PreviewJpg []byte `db:"preview_jpg"`
	ID         int    `db:"id"`
}

func (q *Queries) SetPhotoPreview(ctx context.Context, arg SetPhotoPreviewParams) error {
	_, err := q.db.ExecContext(ctx, setPhotoPreview, arg.PreviewJpg, arg.ID)
	return err
}

const setPhotoThumbnail = `-- name: SetPhotoThumbnail :exec
UPDATE photos
SET
    thumbnail_jpg = ?
WHERE id = ?
`

type SetPhotoThumbnailParams struct {
	ThumbnailJpg []byte `db:"thumbnail_jpg"`
	ID           int    `db:"id"`
}

func (q *Queries) SetPhotoThumbnail(ctx context.Context, arg SetPhotoThumbnailParams) error {
	_, err := q.db.ExecContext(ctx, setPhotoThumbnail, arg.ThumbnailJpg, arg.ID)
	return err
}
