// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.27.0
// source: user_settings.sql

package sqlc

import (
	"context"
	"database/sql"
)

const getUserEmailTwiceWeeklyDigestSubscription = `-- name: GetUserEmailTwiceWeeklyDigestSubscription :many
SELECT u.id, u.email FROM users u 
LEFT JOIN user_settings us on us.user_id = u.id
WHERE 
    (us.key = 'email_digest_subscription' and us.value = 'twice-weekly-digest')
    OR us.key is null
`

type GetUserEmailTwiceWeeklyDigestSubscriptionRow struct {
	ID    int    `db:"id"`
	Email string `db:"email"`
}

// GetUserEmailTwiceWeeklyDigestSubscription retrives user emails that are
// subscribed to the digest emails. If the user has no subscription specified
// the settings table then they are subscribed by default.
func (q *Queries) GetUserEmailTwiceWeeklyDigestSubscription(ctx context.Context) ([]GetUserEmailTwiceWeeklyDigestSubscriptionRow, error) {
	rows, err := q.db.QueryContext(ctx, getUserEmailTwiceWeeklyDigestSubscription)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []GetUserEmailTwiceWeeklyDigestSubscriptionRow
	for rows.Next() {
		var i GetUserEmailTwiceWeeklyDigestSubscriptionRow
		if err := rows.Scan(&i.ID, &i.Email); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getUserSetting = `-- name: GetUserSetting :one
SELECT value FROM user_settings
WHERE user_id = ? AND key = ?
`

type GetUserSettingParams struct {
	UserID int    `db:"user_id"`
	Key    string `db:"key"`
}

func (q *Queries) GetUserSetting(ctx context.Context, arg GetUserSettingParams) (sql.NullString, error) {
	row := q.db.QueryRowContext(ctx, getUserSetting, arg.UserID, arg.Key)
	var value sql.NullString
	err := row.Scan(&value)
	return value, err
}

const setUserSetting = `-- name: SetUserSetting :exec
INSERT INTO user_settings (
    user_id, key, value
) VALUES (
    ?, ?, ?
) ON CONFLICT(user_id, key)
    DO UPDATE SET value = excluded.value
`

type SetUserSettingParams struct {
	UserID int            `db:"user_id"`
	Key    string         `db:"key"`
	Value  sql.NullString `db:"value"`
}

func (q *Queries) SetUserSetting(ctx context.Context, arg SetUserSettingParams) error {
	_, err := q.db.ExecContext(ctx, setUserSetting, arg.UserID, arg.Key, arg.Value)
	return err
}
