// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.27.0
// source: users.sql

package sqlc

import (
	"context"
	"database/sql"
)

const addUserToGroup = `-- name: AddUserToGroup :exec
INSERT INTO user_groups (
    user_id, group_id
) VALUES (
    ?, ?
)
`

type AddUserToGroupParams struct {
	UserID  int `db:"user_id"`
	GroupID int `db:"group_id"`
}

func (q *Queries) AddUserToGroup(ctx context.Context, arg AddUserToGroupParams) error {
	_, err := q.db.ExecContext(ctx, addUserToGroup, arg.UserID, arg.GroupID)
	return err
}

const createUser = `-- name: CreateUser :execlastid
INSERT INTO users (
    name, email, created_at
) VALUES (
    ?, ?, datetime('now')
)
`

type CreateUserParams struct {
	Name  sql.NullString `db:"name"`
	Email string         `db:"email"`
}

func (q *Queries) CreateUser(ctx context.Context, arg CreateUserParams) (int64, error) {
	result, err := q.db.ExecContext(ctx, createUser, arg.Name, arg.Email)
	if err != nil {
		return 0, err
	}
	return result.LastInsertId()
}

const deleteUser = `-- name: DeleteUser :exec
DELETE FROM users
WHERE id = ?
`

// DeleteUser removes a user from the database. All dependent tables including
// posts and photos will cascade.
func (q *Queries) DeleteUser(ctx context.Context, id int) error {
	_, err := q.db.ExecContext(ctx, deleteUser, id)
	return err
}

const getUserByEmail = `-- name: GetUserByEmail :one
SELECT id, email, verified, created_at, name, stripe_customer_id, count_posts_created, count_events_created, count_logins, count_page_loads, last_login, count_bounced_emails, count_posts_response_emails, count_other_incoming_email, digest_marked_spam, admin_marked_spam, user_message_marked_spam, username FROM users
WHERE email = lower(?)
LIMIT 1
`

func (q *Queries) GetUserByEmail(ctx context.Context, lower string) (User, error) {
	row := q.db.QueryRowContext(ctx, getUserByEmail, lower)
	var i User
	err := row.Scan(
		&i.ID,
		&i.Email,
		&i.Verified,
		&i.CreatedAt,
		&i.Name,
		&i.StripeCustomerID,
		&i.CountPostsCreated,
		&i.CountEventsCreated,
		&i.CountLogins,
		&i.CountPageLoads,
		&i.LastLogin,
		&i.CountBouncedEmails,
		&i.CountPostsResponseEmails,
		&i.CountOtherIncomingEmail,
		&i.DigestMarkedSpam,
		&i.AdminMarkedSpam,
		&i.UserMessageMarkedSpam,
		&i.Username,
	)
	return i, err
}

const getUserByID = `-- name: GetUserByID :one
SELECT id, email, verified, created_at, name, stripe_customer_id, count_posts_created, count_events_created, count_logins, count_page_loads, last_login, count_bounced_emails, count_posts_response_emails, count_other_incoming_email, digest_marked_spam, admin_marked_spam, user_message_marked_spam, username FROM users
WHERE id = ?
LIMIT 1
`

func (q *Queries) GetUserByID(ctx context.Context, id int) (User, error) {
	row := q.db.QueryRowContext(ctx, getUserByID, id)
	var i User
	err := row.Scan(
		&i.ID,
		&i.Email,
		&i.Verified,
		&i.CreatedAt,
		&i.Name,
		&i.StripeCustomerID,
		&i.CountPostsCreated,
		&i.CountEventsCreated,
		&i.CountLogins,
		&i.CountPageLoads,
		&i.LastLogin,
		&i.CountBouncedEmails,
		&i.CountPostsResponseEmails,
		&i.CountOtherIncomingEmail,
		&i.DigestMarkedSpam,
		&i.AdminMarkedSpam,
		&i.UserMessageMarkedSpam,
		&i.Username,
	)
	return i, err
}

const getUserCount = `-- name: GetUserCount :one
SELECT COUNT(*) FROM users
`

func (q *Queries) GetUserCount(ctx context.Context) (int, error) {
	row := q.db.QueryRowContext(ctx, getUserCount)
	var count int
	err := row.Scan(&count)
	return count, err
}

const getUserInfo = `-- name: GetUserInfo :one
SELECT name, email FROM users
WHERE id = ?
`

type GetUserInfoRow struct {
	Name  sql.NullString `db:"name"`
	Email string         `db:"email"`
}

func (q *Queries) GetUserInfo(ctx context.Context, id int) (GetUserInfoRow, error) {
	row := q.db.QueryRowContext(ctx, getUserInfo, id)
	var i GetUserInfoRow
	err := row.Scan(&i.Name, &i.Email)
	return i, err
}

const getUsers = `-- name: GetUsers :many
SELECT id, email, verified, created_at, name, stripe_customer_id, count_posts_created, count_events_created, count_logins, count_page_loads, last_login, count_bounced_emails, count_posts_response_emails, count_other_incoming_email, digest_marked_spam, admin_marked_spam, user_message_marked_spam, username FROM users
`

func (q *Queries) GetUsers(ctx context.Context) ([]User, error) {
	rows, err := q.db.QueryContext(ctx, getUsers)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []User
	for rows.Next() {
		var i User
		if err := rows.Scan(
			&i.ID,
			&i.Email,
			&i.Verified,
			&i.CreatedAt,
			&i.Name,
			&i.StripeCustomerID,
			&i.CountPostsCreated,
			&i.CountEventsCreated,
			&i.CountLogins,
			&i.CountPageLoads,
			&i.LastLogin,
			&i.CountBouncedEmails,
			&i.CountPostsResponseEmails,
			&i.CountOtherIncomingEmail,
			&i.DigestMarkedSpam,
			&i.AdminMarkedSpam,
			&i.UserMessageMarkedSpam,
			&i.Username,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const incrementBouncedEmailCount = `-- name: IncrementBouncedEmailCount :exec
UPDATE users
SET
    count_bounced_emails = count_bounced_emails + 1
WHERE email = ?
`

// IncrementBouncedEmailCount increments the number of times we have sent this user an email but it has bounced.
func (q *Queries) IncrementBouncedEmailCount(ctx context.Context, email string) error {
	_, err := q.db.ExecContext(ctx, incrementBouncedEmailCount, email)
	return err
}

const incrementEventsCreatedCount = `-- name: IncrementEventsCreatedCount :exec
UPDATE users
SET
    count_events_created = count_events_created + 1
WHERE id = ?
`

// IncrementEventsCreatedCount increases the counter on the user for number of events they have created.
func (q *Queries) IncrementEventsCreatedCount(ctx context.Context, id int) error {
	_, err := q.db.ExecContext(ctx, incrementEventsCreatedCount, id)
	return err
}

const incrementLoginCount = `-- name: IncrementLoginCount :exec
UPDATE users
SET
    count_logins = count_logins + 1,
    last_login = datetime('now')
WHERE id = ?
`

func (q *Queries) IncrementLoginCount(ctx context.Context, id int) error {
	_, err := q.db.ExecContext(ctx, incrementLoginCount, id)
	return err
}

const incrementPageLoadCount = `-- name: IncrementPageLoadCount :exec
UPDATE users
SET
    count_page_loads = count_page_loads + 1
WHERE id = ?
`

func (q *Queries) IncrementPageLoadCount(ctx context.Context, id int) error {
	_, err := q.db.ExecContext(ctx, incrementPageLoadCount, id)
	return err
}

const incrementPostsCreatedCount = `-- name: IncrementPostsCreatedCount :exec
UPDATE users
SET
    count_posts_created = count_posts_created + 1
WHERE id = ?
`

// IncrementPostsCreatedCount increases the counter on the user for number of posts they have created.
func (q *Queries) IncrementPostsCreatedCount(ctx context.Context, id int) error {
	_, err := q.db.ExecContext(ctx, incrementPostsCreatedCount, id)
	return err
}

const incrementUserEmailOtherCount = `-- name: IncrementUserEmailOtherCount :exec
UPDATE users
SET
    count_other_incoming_email = count_other_incoming_email + 1
WHERE email = ?
`

func (q *Queries) IncrementUserEmailOtherCount(ctx context.Context, email string) error {
	_, err := q.db.ExecContext(ctx, incrementUserEmailOtherCount, email)
	return err
}

const incrementUserEmailResponseCount = `-- name: IncrementUserEmailResponseCount :exec
UPDATE users
SET
    count_posts_response_emails = count_posts_response_emails + 1
WHERE email = ?
`

func (q *Queries) IncrementUserEmailResponseCount(ctx context.Context, email string) error {
	_, err := q.db.ExecContext(ctx, incrementUserEmailResponseCount, email)
	return err
}

const searchUsers = `-- name: SearchUsers :many
SELECT id, email, verified, created_at, name, stripe_customer_id, count_posts_created, count_events_created, count_logins, count_page_loads, last_login, count_bounced_emails, count_posts_response_emails, count_other_incoming_email, digest_marked_spam, admin_marked_spam, user_message_marked_spam, username FROM users
WHERE
    name LIKE ?
    OR email like ?
`

type SearchUsersParams struct {
	Name  sql.NullString `db:"name"`
	Email string         `db:"email"`
}

func (q *Queries) SearchUsers(ctx context.Context, arg SearchUsersParams) ([]User, error) {
	rows, err := q.db.QueryContext(ctx, searchUsers, arg.Name, arg.Email)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []User
	for rows.Next() {
		var i User
		if err := rows.Scan(
			&i.ID,
			&i.Email,
			&i.Verified,
			&i.CreatedAt,
			&i.Name,
			&i.StripeCustomerID,
			&i.CountPostsCreated,
			&i.CountEventsCreated,
			&i.CountLogins,
			&i.CountPageLoads,
			&i.LastLogin,
			&i.CountBouncedEmails,
			&i.CountPostsResponseEmails,
			&i.CountOtherIncomingEmail,
			&i.DigestMarkedSpam,
			&i.AdminMarkedSpam,
			&i.UserMessageMarkedSpam,
			&i.Username,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const setAdminMarkedSpam = `-- name: SetAdminMarkedSpam :exec
UPDATE users
SET
    admin_marked_spam = true
WHERE email = ?
`

func (q *Queries) SetAdminMarkedSpam(ctx context.Context, email string) error {
	_, err := q.db.ExecContext(ctx, setAdminMarkedSpam, email)
	return err
}

const setDigestMarkedSpam = `-- name: SetDigestMarkedSpam :exec
UPDATE users
SET
    digest_marked_spam = true
WHERE email = ?
`

func (q *Queries) SetDigestMarkedSpam(ctx context.Context, email string) error {
	_, err := q.db.ExecContext(ctx, setDigestMarkedSpam, email)
	return err
}

const setUserMessageMarkedSpam = `-- name: SetUserMessageMarkedSpam :exec
UPDATE users
SET
    user_message_marked_spam = true
WHERE email = ?
`

func (q *Queries) SetUserMessageMarkedSpam(ctx context.Context, email string) error {
	_, err := q.db.ExecContext(ctx, setUserMessageMarkedSpam, email)
	return err
}

const setUserName = `-- name: SetUserName :exec
UPDATE users
SET name = ?
WHERE id = ?
`

type SetUserNameParams struct {
	Name sql.NullString `db:"name"`
	ID   int            `db:"id"`
}

func (q *Queries) SetUserName(ctx context.Context, arg SetUserNameParams) error {
	_, err := q.db.ExecContext(ctx, setUserName, arg.Name, arg.ID)
	return err
}

const setUserNameIfEmpty = `-- name: SetUserNameIfEmpty :exec
UPDATE users
SET
    name = ?
WHERE email = ? AND name is null
`

type SetUserNameIfEmptyParams struct {
	Name  sql.NullString `db:"name"`
	Email string         `db:"email"`
}

func (q *Queries) SetUserNameIfEmpty(ctx context.Context, arg SetUserNameIfEmptyParams) error {
	_, err := q.db.ExecContext(ctx, setUserNameIfEmpty, arg.Name, arg.Email)
	return err
}

const setUserStripeCustomerID = `-- name: SetUserStripeCustomerID :exec
UPDATE users
SET stripe_customer_id = ?
WHERE email = ?
`

type SetUserStripeCustomerIDParams struct {
	StripeCustomerID sql.NullString `db:"stripe_customer_id"`
	Email            string         `db:"email"`
}

func (q *Queries) SetUserStripeCustomerID(ctx context.Context, arg SetUserStripeCustomerIDParams) error {
	_, err := q.db.ExecContext(ctx, setUserStripeCustomerID, arg.StripeCustomerID, arg.Email)
	return err
}

const setUserUsername = `-- name: SetUserUsername :exec
UPDATE users
SET username = ?
WHERE id = ?
`

type SetUserUsernameParams struct {
	Username sql.NullString `db:"username"`
	ID       int            `db:"id"`
}

func (q *Queries) SetUserUsername(ctx context.Context, arg SetUserUsernameParams) error {
	_, err := q.db.ExecContext(ctx, setUserUsername, arg.Username, arg.ID)
	return err
}

const setUserVerified = `-- name: SetUserVerified :exec
UPDATE users
SET verified = true
WHERE id = ?
`

func (q *Queries) SetUserVerified(ctx context.Context, id int) error {
	_, err := q.db.ExecContext(ctx, setUserVerified, id)
	return err
}
