package admin

import (
	"github.com/labstack/echo/v4"

	"git.grosinger.net/tgrosinger/tonyslist/constants/pages"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/middleware"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/services"
)

type adminCtr struct {
	controller.Controller
}

func BuildRoutes(c *services.Container, g *echo.Group, ctr controller.Controller) {
	sg := g.Group("/admin", middleware.RequireAdmin(c.DB, c.Enforcer))

	adminCtr := adminCtr{Controller: ctr}

	sg.GET("", adminCtr.GetHome).Name = pages.Names.Admin.Home
	sg.GET("/users", adminCtr.GetUsers).Name = pages.Names.Admin.Users
	sg.GET("/users/:id", adminCtr.GetUserDetails).Name = pages.Names.Admin.UserDetails
	sg.PATCH("/users/:id", adminCtr.PatchUserDetails)
	sg.GET("/users/:id/delete", adminCtr.GetDeleteUser).Name = pages.Names.Admin.UserDelete
	sg.POST("/users/:id/delete", adminCtr.PostDeleteUser)
}
