package routes

import (
	"fmt"

	"github.com/labstack/echo/v4"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/views"
)

type help struct {
	controller.Controller
}

func (c *help) render(ctx echo.Context, filename string) error {
	page := controller.NewPage(ctx, c.Container)
	page.Metatags.Description = fmt.Sprintf(
		"%s Help Pages.", c.Container.Config.App.Name)

	renderedMarkdown, err := c.LoadMarkdown(ctx, filename)
	if err != nil {
		return err
	}

	v := views.MarkdownView{
		Content: renderedMarkdown,
		Page:    page,
	}
	return c.RenderHTML(ctx, page, &v)
}

func (c *help) Index(ctx echo.Context) error {
	return c.render(ctx, "help-index.md")
}

func (c *help) ClassifiedSearch(ctx echo.Context) error {
	return c.render(ctx, "help-classified-search.md")
}

func (c *help) ClassifiedRSS(ctx echo.Context) error {
	return c.render(ctx, "help-classified-rss.md")
}

func (c *help) ClassifiedMarkdown(ctx echo.Context) error {
	return c.render(ctx, "help-classified-markdown.md")
}
