package hooks

import (
	"crypto/subtle"

	"github.com/labstack/echo/v4"
	"github.com/labstack/echo/v4/middleware"

	"git.grosinger.net/tgrosinger/tonyslist/constants/pages"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/services"
)

func BuildRoutes(c *services.Container, g *echo.Group, ctr controller.Controller) {
	sg := g.Group("/hooks", middleware.BasicAuth(func(username, password string, ctx echo.Context) (bool, error) {
		equal := subtle.ConstantTimeCompare([]byte(username), []byte(c.Config.App.HooksUsername)) == 1 &&
			subtle.ConstantTimeCompare([]byte(password), []byte(c.Config.App.HooksPassword)) == 1
		return equal, nil
	}))

	incomingEmail := incomingEmail{Controller: ctr}
	sg.POST("/support-email", incomingEmail.Post).Name = pages.Names.Hooks.IncomingEmail

	deliverability := deliverability{Controller: ctr}
	sg.POST("/deliverability", deliverability.Post).Name = pages.Names.Hooks.Deliverability
}
