package routes

import (
	"github.com/labstack/echo/v4"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/views"
)

type (
	policies struct {
		controller.Controller
	}
)

func (c *policies) GetFAQ(ctx echo.Context) error {
	page := controller.NewPage(ctx, c.Container)
	page.Title = "FAQ"
	page.Metatags.Description = c.Container.Config.App.Name + " Frequently Asked Questions"
	page.Metatags.Keywords = []string{"Classifieds", "Community"}

	renderedMarkdown, err := c.LoadMarkdown(ctx, "faq.md")
	if err != nil {
		return err
	}

	v := views.MarkdownView{
		Content: renderedMarkdown,
		Page:    page,
	}
	return c.RenderHTML(ctx, page, &v)
}

func (c *policies) GetTermsOfService(ctx echo.Context) error {
	page := controller.NewPage(ctx, c.Container)
	page.Title = "Terms of Service"
	page.Metatags.Description = c.Container.Config.App.Name + " Terms of Service"
	page.Metatags.Keywords = []string{"Classifieds", "Community"}

	renderedMarkdown, err := c.LoadMarkdown(ctx, "terms-of-service.md")
	if err != nil {
		return err
	}

	v := views.MarkdownView{
		Content: renderedMarkdown,
		Page:    page,
	}
	return c.RenderHTML(ctx, page, &v)
}

func (c *policies) GetPrivacyPolicy(ctx echo.Context) error {
	page := controller.NewPage(ctx, c.Container)
	page.Title = "Privacy Policy"
	page.Metatags.Description = c.Container.Config.App.Name + " Privacy Policy"
	page.Metatags.Keywords = []string{"Classifieds", "Community"}

	renderedMarkdown, err := c.LoadMarkdown(ctx, "privacy-policy.md")
	if err != nil {
		return err
	}

	v := views.MarkdownView{
		Content: renderedMarkdown,
		Page:    page,
	}
	return c.RenderHTML(ctx, page, &v)
}
