package postbase

import (
	"github.com/labstack/echo/v4"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/context"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/models/postbase"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/msg"
)

func (c *commonController) PublishPost(ctx echo.Context) error {
	p, ok := ctx.Get(context.PostBaseKey).(*postbase.PostBase)
	if !ok {
		msg.Warning(ctx, "The requested post could not be found.")
		return c.RedirectToPostBrowser(ctx)
	}

	err := c.Container.DB.C.SetPostPublishedNow(ctx.Request().Context(), p.ID)
	if err != nil {
		return c.Fail(err, "unable to publish the post")
	}

	return c.RedirectToPost(ctx, p)
}
