package routes

import (
	"net/http"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
	"github.com/labstack/echo/v4"
)

type Tus struct {
	Controller controller.Controller
}

// Handle serves the various endpoints exposed by tus.
// We strip the incoming path prefix because it is already accounted for by the
// echo router.
func (c *Tus) Handle(ctx echo.Context) error {
	tusHandler := c.Controller.Container.Tus.Handler
	http.StripPrefix("/uploads", tusHandler).ServeHTTP(ctx.Response(), ctx.Request())
	return nil
}
