package tasks

import (
	"fmt"
	"math"
	"math/rand"
	"testing"

	"github.com/stretchr/testify/require"
)

func TestLocationJitter(t *testing.T) {
	for i := 0; i < 100; i++ {
		t.Run(fmt.Sprintf("Test %d", i), func(t *testing.T) {
			l := Location{
				Latitude:  rand.Float64() * 10,
				Longitude: rand.Float64() * 10,
			}

			lj := l.Jitter()

			require.LessOrEqual(t, math.Abs(lj.Latitude-l.Latitude), 0.01)
			require.LessOrEqual(t, math.Abs(lj.Longitude-l.Longitude), 0.01)
		})
	}
}
