package views

import (
	"io"
	"net/http"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
	c "git.grosinger.net/tgrosinger/tonyslist/pkg/views/components"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/views/layouts"
)

// ActionConfirmationForm is not really actually used, it's just an empty form
// for the callers of the ActionConfirmation view to use.
type ActionConfirmationForm struct {
	Submission controller.FormSubmission
}

type ActionConfirmation struct {
	Heading     string
	Prompt      string
	ButtonText  string
	Destructive bool

	Page controller.Page
}

func (v *ActionConfirmation) Render(w io.Writer) error {
	content := c.NarrowContainer(
		c.FullScreenForm(
			http.MethodPost,
			v.Page.Path,
			"",
			"",
			c.FormFooter(nil, "back", v.ButtonText, v.Destructive),
			c.FormSection(
				c.FormHeading(v.Heading, v.Prompt),
				c.CSRF(v.Page))),
	)

	l := layouts.Primary{
		Content: content,
		Page:    v.Page,
	}
	return l.Render(w)
}
