package views

import (
	"io"

	g "maragu.dev/gomponents"
	h "maragu.dev/gomponents/html"

	"git.grosinger.net/tgrosinger/tonyslist/constants/pages"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
	c "git.grosinger.net/tgrosinger/tonyslist/pkg/views/components"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/views/layouts"
)

type AdminHome struct {
	Page controller.Page
}

func (v *AdminHome) Render(w io.Writer) error {
	content := c.NarrowContainer(
		c.CenteredX(
			v.Links()))

	l := layouts.Primary{
		Header: c.HeaderContainer(
			c.Breadcrumbs([]c.BreadcrumbPart{
				{
					Display: "Admin",
				},
			},
			),
			nil,
		),
		Content: content,
		Page:    v.Page,
	}

	return l.Render(w)
}

func (v *AdminHome) Links() g.Node {
	return h.Div(
		h.Class("grid grid-cols-1 gap-4 sm:grid-cols-2"),
		g.Group([]g.Node{
			v.link("Users", v.Page.ToURL(pages.Names.Admin.Users)),
			v.link("Emails", v.Page.ToURL(pages.Names.Admin.Emails)),
		}))
}

func (v *AdminHome) link(display, href string) g.Node {
	return h.Div(
		h.Class("relative flex items-center space-x-3 rounded-lg border border-gray-300 bg-white px-6 py-5 shadow-sm focus-within:ring-2 focus-within:ring-indigo-500 focus-within:ring-offset-2 hover:border-gray-400"),
		h.Div(
			h.Class("min-w-0 flex-1"),
			h.A(
				h.Class("focus:outline-none"),
				h.Href(href),
				h.P(
					h.Class("text-sm font-medium text-gray-900"),
					g.Text(display)))))
}
