package components

import (
	g "maragu.dev/gomponents"
	h "maragu.dev/gomponents/html"
)

type (
	ListCell g.Node
	ListRow  g.Node
)

func DescriptionList(rows ...ListRow) g.Node {
	return h.Dl(
		h.Class("grid grid-cols-1 sm:grid-cols-2 gap-2"),
		g.Map(rows, func(r ListRow) g.Node { return g.Node(r) }))
}

func MakeTwoColumnRow(left, right ListCell) ListRow {
	return g.Group{
		h.Div(
			h.Class("px-4 py-6 sm:col-span-1 sm:px-0"),
			left),
		h.Div(
			h.Class("px-4 py-6 sm:col-span-1 sm:px-0"),
			right),
	}
}

func MakeOneColumnRow(fullWidthCell ListCell) ListRow {
	return h.Div(
		h.Class("px-4 py-6 sm:col-span-2 sm:px-0"),
		fullWidthCell)
}

func MakeCell(key string, value g.Node) ListCell {
	return g.Group{
		h.Dt(
			h.Class("text-sm/6 font-medium text-gray-900"),
			g.Text(key)),
		h.Dd(
			h.Class("mt-1 text-sm/6 text-gray-700 sm:mt-2"),
			value),
	}
}
