package components

import (
	g "maragu.dev/gomponents"
	h "maragu.dev/gomponents/html"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/views/helpers"
)

// Favicon creates a favicon link element.  Size is an optional field and
// filename is the name of the file assumed to be in the static file directory.
func Favicon(imgType, size, filename string) g.Node {
	return StaticFileLink(filename,
		h.Rel("icon"),
		h.Type(imgType),
		LazyIf(size != "", func() g.Node {
			return g.Attr("sizes", size)
		}))
}

func StaticFileLink(filename string, attrs ...g.Node) g.Node {
	return h.Link(
		g.Group(attrs),
		h.Href(helpers.FileNoBuster(filename)))
}
