package components

import (
	g "maragu.dev/gomponents"
	comp "maragu.dev/gomponents/components"
	h "maragu.dev/gomponents/html"
)

func Table(headCols []g.Node, rows []g.Node) g.Node {
	return h.Table(
		h.Class("min-w-full divide-y divide-gray-300"),
		h.THead(
			h.Class("bg-gray-50"),
			h.Tr(
				g.Group(headCols))),
		h.TBody(
			h.Class("divide-y divide-gray-200 bg-white"),
			g.Group(rows)))
}

func TableHeaderCol(name, extraClasses string, hidden bool) g.Node {
	return h.Th(
		g.Attr("Scope", "col"),
		h.Class("px-3 py-3.5 text-left text-sm font-semibold text-gray-900 "+extraClasses),
		h.Span(
			comp.Classes{
				"sr-only": hidden,
			},
			g.Text(name)))
}
