package views

import (
	"io"

	g "maragu.dev/gomponents"
	h "maragu.dev/gomponents/html"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
	c "git.grosinger.net/tgrosinger/tonyslist/pkg/views/components"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/views/layouts"
)

type Editor struct {
	Page           controller.Page
	BecomeAnEditor string
}

func (v *Editor) Render(w io.Writer) error {
	content := h.Div(
		c.NarrowContainer(
			c.MarkdownRenderingContainer(v.BecomeAnEditor),
			h.Div(
				h.Class("flex gap-x-4"),
				c.ButtonPrimary("https://groups.orcashub.org/g/comm-res-editors", g.Text("Become an editor")),
				c.ButtonSecondary("https://groups.orcashub.org/c/resources", g.Text("Already an editor")),
			),
		),
	)

	l := layouts.Primary{
		Content: content,
		Page:    v.Page,
	}
	return l.Render(w)
}
