package helpers

// TODO: Move other functions from funcmap into this package, like RSSLink.

// PageNums outputs a list of page numbers for use during pagination.
// Outputs 7 pages (if there are that many) centered on the current page when
// possible.
func PageNums(numPages int, currentPage int) []int {
	start := currentPage - 3
	if numPages-7 < start {
		start = numPages - 6
	}
	if start < 1 {
		start = 1
	}

	end := start + 6
	if end > numPages {
		end = numPages
	}

	nums := make([]int, 0, (end-start)+1)
	for i := start; i <= end; i++ {
		nums = append(nums, i)
	}
	return nums
}
