package views

import (
	"io"

	"git.grosinger.net/tgrosinger/tonyslist/pkg/controller"
	c "git.grosinger.net/tgrosinger/tonyslist/pkg/views/components"
	"git.grosinger.net/tgrosinger/tonyslist/pkg/views/layouts"
)

type MarkdownView struct {
	Content string

	Page controller.Page
}

func (v *MarkdownView) Render(w io.Writer) error {
	content := c.WideContainer(
		c.MarkdownRenderingContainer(v.Content),
	)

	l := layouts.Primary{
		Content: content,
		Page:    v.Page,
	}
	return l.Render(w)
}
