(()=>{
    var intervalID = 0;
    var checkCount = 0;

    const getEmail = () => 
        document.getElementById("email-address").innerText;

    const checkStatus = async (email) => {
        const response = await fetch("/api/deliverability/login?email=" + email);
        const jsonData = await response.json();
        return jsonData["status"];
    };

    const showErrorMessage = () => {
        document.getElementById("checking-message").className = "hidden";
        document.getElementById("error-message").className = "";
    };

    const showSuccessMessage = () => {
        document.getElementById("checking-message").className = "hidden";
        document.getElementById("success-message").className = "";
    };

    const updateStatus = async () => {
        checkCount++;
        if (checkCount > 300) {
            clearInterval(intervalID);
        }

        console.debug("Checking the deliverability status")
        const status = await checkStatus(getEmail());
        switch (status) {
            case "unknown":
                return;
            case "bounce":
                clearInterval(intervalID);
                showErrorMessage();
                break;
            case "delivered":
                clearInterval(intervalID);
                showSuccessMessage();
                break;
            default:
                console.error(`Unexpected status returned by api: ${status}`);
        }
    };

    intervalID = setInterval(updateStatus, 1000);
})();