//
//
// File generated from our OpenAPI spec
//
//

package stripe

import "github.com/stripe/stripe-go/v78/form"

// Type of registration in `country`.
type TaxRegistrationCountryOptionsAeType string

// List of values that TaxRegistrationCountryOptionsAeType can take
const (
	TaxRegistrationCountryOptionsAeTypeStandard TaxRegistrationCountryOptionsAeType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsAtStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsAtStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsAtStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsAtStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsAtStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsAtStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsAtType string

// List of values that TaxRegistrationCountryOptionsAtType can take
const (
	TaxRegistrationCountryOptionsAtTypeIoss        TaxRegistrationCountryOptionsAtType = "ioss"
	TaxRegistrationCountryOptionsAtTypeOssNonUnion TaxRegistrationCountryOptionsAtType = "oss_non_union"
	TaxRegistrationCountryOptionsAtTypeOssUnion    TaxRegistrationCountryOptionsAtType = "oss_union"
	TaxRegistrationCountryOptionsAtTypeStandard    TaxRegistrationCountryOptionsAtType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsAuType string

// List of values that TaxRegistrationCountryOptionsAuType can take
const (
	TaxRegistrationCountryOptionsAuTypeStandard TaxRegistrationCountryOptionsAuType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsBeStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsBeStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsBeStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsBeStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsBeStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsBeStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsBeType string

// List of values that TaxRegistrationCountryOptionsBeType can take
const (
	TaxRegistrationCountryOptionsBeTypeIoss        TaxRegistrationCountryOptionsBeType = "ioss"
	TaxRegistrationCountryOptionsBeTypeOssNonUnion TaxRegistrationCountryOptionsBeType = "oss_non_union"
	TaxRegistrationCountryOptionsBeTypeOssUnion    TaxRegistrationCountryOptionsBeType = "oss_union"
	TaxRegistrationCountryOptionsBeTypeStandard    TaxRegistrationCountryOptionsBeType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsBGStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsBGStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsBGStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsBGStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsBGStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsBGStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsBGType string

// List of values that TaxRegistrationCountryOptionsBGType can take
const (
	TaxRegistrationCountryOptionsBGTypeIoss        TaxRegistrationCountryOptionsBGType = "ioss"
	TaxRegistrationCountryOptionsBGTypeOssNonUnion TaxRegistrationCountryOptionsBGType = "oss_non_union"
	TaxRegistrationCountryOptionsBGTypeOssUnion    TaxRegistrationCountryOptionsBGType = "oss_union"
	TaxRegistrationCountryOptionsBGTypeStandard    TaxRegistrationCountryOptionsBGType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsBhType string

// List of values that TaxRegistrationCountryOptionsBhType can take
const (
	TaxRegistrationCountryOptionsBhTypeStandard TaxRegistrationCountryOptionsBhType = "standard"
)

// Type of registration in Canada.
type TaxRegistrationCountryOptionsCaType string

// List of values that TaxRegistrationCountryOptionsCaType can take
const (
	TaxRegistrationCountryOptionsCaTypeProvinceStandard TaxRegistrationCountryOptionsCaType = "province_standard"
	TaxRegistrationCountryOptionsCaTypeSimplified       TaxRegistrationCountryOptionsCaType = "simplified"
	TaxRegistrationCountryOptionsCaTypeStandard         TaxRegistrationCountryOptionsCaType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsChType string

// List of values that TaxRegistrationCountryOptionsChType can take
const (
	TaxRegistrationCountryOptionsChTypeStandard TaxRegistrationCountryOptionsChType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsClType string

// List of values that TaxRegistrationCountryOptionsClType can take
const (
	TaxRegistrationCountryOptionsClTypeSimplified TaxRegistrationCountryOptionsClType = "simplified"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsCoType string

// List of values that TaxRegistrationCountryOptionsCoType can take
const (
	TaxRegistrationCountryOptionsCoTypeSimplified TaxRegistrationCountryOptionsCoType = "simplified"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsCyStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsCyStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsCyStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsCyStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsCyStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsCyStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsCyType string

// List of values that TaxRegistrationCountryOptionsCyType can take
const (
	TaxRegistrationCountryOptionsCyTypeIoss        TaxRegistrationCountryOptionsCyType = "ioss"
	TaxRegistrationCountryOptionsCyTypeOssNonUnion TaxRegistrationCountryOptionsCyType = "oss_non_union"
	TaxRegistrationCountryOptionsCyTypeOssUnion    TaxRegistrationCountryOptionsCyType = "oss_union"
	TaxRegistrationCountryOptionsCyTypeStandard    TaxRegistrationCountryOptionsCyType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsCzStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsCzStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsCzStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsCzStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsCzStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsCzStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsCzType string

// List of values that TaxRegistrationCountryOptionsCzType can take
const (
	TaxRegistrationCountryOptionsCzTypeIoss        TaxRegistrationCountryOptionsCzType = "ioss"
	TaxRegistrationCountryOptionsCzTypeOssNonUnion TaxRegistrationCountryOptionsCzType = "oss_non_union"
	TaxRegistrationCountryOptionsCzTypeOssUnion    TaxRegistrationCountryOptionsCzType = "oss_union"
	TaxRegistrationCountryOptionsCzTypeStandard    TaxRegistrationCountryOptionsCzType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsDEStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsDEStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsDEStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsDEStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsDEStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsDEStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsDEType string

// List of values that TaxRegistrationCountryOptionsDEType can take
const (
	TaxRegistrationCountryOptionsDETypeIoss        TaxRegistrationCountryOptionsDEType = "ioss"
	TaxRegistrationCountryOptionsDETypeOssNonUnion TaxRegistrationCountryOptionsDEType = "oss_non_union"
	TaxRegistrationCountryOptionsDETypeOssUnion    TaxRegistrationCountryOptionsDEType = "oss_union"
	TaxRegistrationCountryOptionsDETypeStandard    TaxRegistrationCountryOptionsDEType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsDkStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsDkStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsDkStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsDkStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsDkStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsDkStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsDkType string

// List of values that TaxRegistrationCountryOptionsDkType can take
const (
	TaxRegistrationCountryOptionsDkTypeIoss        TaxRegistrationCountryOptionsDkType = "ioss"
	TaxRegistrationCountryOptionsDkTypeOssNonUnion TaxRegistrationCountryOptionsDkType = "oss_non_union"
	TaxRegistrationCountryOptionsDkTypeOssUnion    TaxRegistrationCountryOptionsDkType = "oss_union"
	TaxRegistrationCountryOptionsDkTypeStandard    TaxRegistrationCountryOptionsDkType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsEeStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsEeStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsEeStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsEeStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsEeStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsEeStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsEeType string

// List of values that TaxRegistrationCountryOptionsEeType can take
const (
	TaxRegistrationCountryOptionsEeTypeIoss        TaxRegistrationCountryOptionsEeType = "ioss"
	TaxRegistrationCountryOptionsEeTypeOssNonUnion TaxRegistrationCountryOptionsEeType = "oss_non_union"
	TaxRegistrationCountryOptionsEeTypeOssUnion    TaxRegistrationCountryOptionsEeType = "oss_union"
	TaxRegistrationCountryOptionsEeTypeStandard    TaxRegistrationCountryOptionsEeType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsEgType string

// List of values that TaxRegistrationCountryOptionsEgType can take
const (
	TaxRegistrationCountryOptionsEgTypeSimplified TaxRegistrationCountryOptionsEgType = "simplified"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsESStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsESStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsESStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsESStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsESStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsESStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsESType string

// List of values that TaxRegistrationCountryOptionsESType can take
const (
	TaxRegistrationCountryOptionsESTypeIoss        TaxRegistrationCountryOptionsESType = "ioss"
	TaxRegistrationCountryOptionsESTypeOssNonUnion TaxRegistrationCountryOptionsESType = "oss_non_union"
	TaxRegistrationCountryOptionsESTypeOssUnion    TaxRegistrationCountryOptionsESType = "oss_union"
	TaxRegistrationCountryOptionsESTypeStandard    TaxRegistrationCountryOptionsESType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsFIStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsFIStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsFIStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsFIStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsFIStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsFIStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsFIType string

// List of values that TaxRegistrationCountryOptionsFIType can take
const (
	TaxRegistrationCountryOptionsFITypeIoss        TaxRegistrationCountryOptionsFIType = "ioss"
	TaxRegistrationCountryOptionsFITypeOssNonUnion TaxRegistrationCountryOptionsFIType = "oss_non_union"
	TaxRegistrationCountryOptionsFITypeOssUnion    TaxRegistrationCountryOptionsFIType = "oss_union"
	TaxRegistrationCountryOptionsFITypeStandard    TaxRegistrationCountryOptionsFIType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsFRStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsFRStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsFRStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsFRStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsFRStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsFRStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsFRType string

// List of values that TaxRegistrationCountryOptionsFRType can take
const (
	TaxRegistrationCountryOptionsFRTypeIoss        TaxRegistrationCountryOptionsFRType = "ioss"
	TaxRegistrationCountryOptionsFRTypeOssNonUnion TaxRegistrationCountryOptionsFRType = "oss_non_union"
	TaxRegistrationCountryOptionsFRTypeOssUnion    TaxRegistrationCountryOptionsFRType = "oss_union"
	TaxRegistrationCountryOptionsFRTypeStandard    TaxRegistrationCountryOptionsFRType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsGBType string

// List of values that TaxRegistrationCountryOptionsGBType can take
const (
	TaxRegistrationCountryOptionsGBTypeStandard TaxRegistrationCountryOptionsGBType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsGeType string

// List of values that TaxRegistrationCountryOptionsGeType can take
const (
	TaxRegistrationCountryOptionsGeTypeSimplified TaxRegistrationCountryOptionsGeType = "simplified"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsGrStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsGrStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsGrStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsGrStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsGrStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsGrStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsGrType string

// List of values that TaxRegistrationCountryOptionsGrType can take
const (
	TaxRegistrationCountryOptionsGrTypeIoss        TaxRegistrationCountryOptionsGrType = "ioss"
	TaxRegistrationCountryOptionsGrTypeOssNonUnion TaxRegistrationCountryOptionsGrType = "oss_non_union"
	TaxRegistrationCountryOptionsGrTypeOssUnion    TaxRegistrationCountryOptionsGrType = "oss_union"
	TaxRegistrationCountryOptionsGrTypeStandard    TaxRegistrationCountryOptionsGrType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsHRStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsHRStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsHRStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsHRStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsHRStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsHRStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsHRType string

// List of values that TaxRegistrationCountryOptionsHRType can take
const (
	TaxRegistrationCountryOptionsHRTypeIoss        TaxRegistrationCountryOptionsHRType = "ioss"
	TaxRegistrationCountryOptionsHRTypeOssNonUnion TaxRegistrationCountryOptionsHRType = "oss_non_union"
	TaxRegistrationCountryOptionsHRTypeOssUnion    TaxRegistrationCountryOptionsHRType = "oss_union"
	TaxRegistrationCountryOptionsHRTypeStandard    TaxRegistrationCountryOptionsHRType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsHUStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsHUStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsHUStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsHUStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsHUStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsHUStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsHUType string

// List of values that TaxRegistrationCountryOptionsHUType can take
const (
	TaxRegistrationCountryOptionsHUTypeIoss        TaxRegistrationCountryOptionsHUType = "ioss"
	TaxRegistrationCountryOptionsHUTypeOssNonUnion TaxRegistrationCountryOptionsHUType = "oss_non_union"
	TaxRegistrationCountryOptionsHUTypeOssUnion    TaxRegistrationCountryOptionsHUType = "oss_union"
	TaxRegistrationCountryOptionsHUTypeStandard    TaxRegistrationCountryOptionsHUType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsIDType string

// List of values that TaxRegistrationCountryOptionsIDType can take
const (
	TaxRegistrationCountryOptionsIDTypeSimplified TaxRegistrationCountryOptionsIDType = "simplified"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsIeStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsIeStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsIeStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsIeStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsIeStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsIeStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsIeType string

// List of values that TaxRegistrationCountryOptionsIeType can take
const (
	TaxRegistrationCountryOptionsIeTypeIoss        TaxRegistrationCountryOptionsIeType = "ioss"
	TaxRegistrationCountryOptionsIeTypeOssNonUnion TaxRegistrationCountryOptionsIeType = "oss_non_union"
	TaxRegistrationCountryOptionsIeTypeOssUnion    TaxRegistrationCountryOptionsIeType = "oss_union"
	TaxRegistrationCountryOptionsIeTypeStandard    TaxRegistrationCountryOptionsIeType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsIsType string

// List of values that TaxRegistrationCountryOptionsIsType can take
const (
	TaxRegistrationCountryOptionsIsTypeStandard TaxRegistrationCountryOptionsIsType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsITStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsITStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsITStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsITStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsITStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsITStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsITType string

// List of values that TaxRegistrationCountryOptionsITType can take
const (
	TaxRegistrationCountryOptionsITTypeIoss        TaxRegistrationCountryOptionsITType = "ioss"
	TaxRegistrationCountryOptionsITTypeOssNonUnion TaxRegistrationCountryOptionsITType = "oss_non_union"
	TaxRegistrationCountryOptionsITTypeOssUnion    TaxRegistrationCountryOptionsITType = "oss_union"
	TaxRegistrationCountryOptionsITTypeStandard    TaxRegistrationCountryOptionsITType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsJPType string

// List of values that TaxRegistrationCountryOptionsJPType can take
const (
	TaxRegistrationCountryOptionsJPTypeStandard TaxRegistrationCountryOptionsJPType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsKeType string

// List of values that TaxRegistrationCountryOptionsKeType can take
const (
	TaxRegistrationCountryOptionsKeTypeSimplified TaxRegistrationCountryOptionsKeType = "simplified"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsKrType string

// List of values that TaxRegistrationCountryOptionsKrType can take
const (
	TaxRegistrationCountryOptionsKrTypeSimplified TaxRegistrationCountryOptionsKrType = "simplified"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsKzType string

// List of values that TaxRegistrationCountryOptionsKzType can take
const (
	TaxRegistrationCountryOptionsKzTypeSimplified TaxRegistrationCountryOptionsKzType = "simplified"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsLTStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsLTStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsLTStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsLTStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsLTStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsLTStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsLTType string

// List of values that TaxRegistrationCountryOptionsLTType can take
const (
	TaxRegistrationCountryOptionsLTTypeIoss        TaxRegistrationCountryOptionsLTType = "ioss"
	TaxRegistrationCountryOptionsLTTypeOssNonUnion TaxRegistrationCountryOptionsLTType = "oss_non_union"
	TaxRegistrationCountryOptionsLTTypeOssUnion    TaxRegistrationCountryOptionsLTType = "oss_union"
	TaxRegistrationCountryOptionsLTTypeStandard    TaxRegistrationCountryOptionsLTType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsLuStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsLuStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsLuStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsLuStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsLuStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsLuStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsLuType string

// List of values that TaxRegistrationCountryOptionsLuType can take
const (
	TaxRegistrationCountryOptionsLuTypeIoss        TaxRegistrationCountryOptionsLuType = "ioss"
	TaxRegistrationCountryOptionsLuTypeOssNonUnion TaxRegistrationCountryOptionsLuType = "oss_non_union"
	TaxRegistrationCountryOptionsLuTypeOssUnion    TaxRegistrationCountryOptionsLuType = "oss_union"
	TaxRegistrationCountryOptionsLuTypeStandard    TaxRegistrationCountryOptionsLuType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsLVStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsLVStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsLVStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsLVStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsLVStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsLVStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsLVType string

// List of values that TaxRegistrationCountryOptionsLVType can take
const (
	TaxRegistrationCountryOptionsLVTypeIoss        TaxRegistrationCountryOptionsLVType = "ioss"
	TaxRegistrationCountryOptionsLVTypeOssNonUnion TaxRegistrationCountryOptionsLVType = "oss_non_union"
	TaxRegistrationCountryOptionsLVTypeOssUnion    TaxRegistrationCountryOptionsLVType = "oss_union"
	TaxRegistrationCountryOptionsLVTypeStandard    TaxRegistrationCountryOptionsLVType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsMTStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsMTStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsMTStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsMTStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsMTStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsMTStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsMTType string

// List of values that TaxRegistrationCountryOptionsMTType can take
const (
	TaxRegistrationCountryOptionsMTTypeIoss        TaxRegistrationCountryOptionsMTType = "ioss"
	TaxRegistrationCountryOptionsMTTypeOssNonUnion TaxRegistrationCountryOptionsMTType = "oss_non_union"
	TaxRegistrationCountryOptionsMTTypeOssUnion    TaxRegistrationCountryOptionsMTType = "oss_union"
	TaxRegistrationCountryOptionsMTTypeStandard    TaxRegistrationCountryOptionsMTType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsMXType string

// List of values that TaxRegistrationCountryOptionsMXType can take
const (
	TaxRegistrationCountryOptionsMXTypeSimplified TaxRegistrationCountryOptionsMXType = "simplified"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsMyType string

// List of values that TaxRegistrationCountryOptionsMyType can take
const (
	TaxRegistrationCountryOptionsMyTypeSimplified TaxRegistrationCountryOptionsMyType = "simplified"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsNgType string

// List of values that TaxRegistrationCountryOptionsNgType can take
const (
	TaxRegistrationCountryOptionsNgTypeSimplified TaxRegistrationCountryOptionsNgType = "simplified"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsNLStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsNLStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsNLStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsNLStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsNLStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsNLStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsNLType string

// List of values that TaxRegistrationCountryOptionsNLType can take
const (
	TaxRegistrationCountryOptionsNLTypeIoss        TaxRegistrationCountryOptionsNLType = "ioss"
	TaxRegistrationCountryOptionsNLTypeOssNonUnion TaxRegistrationCountryOptionsNLType = "oss_non_union"
	TaxRegistrationCountryOptionsNLTypeOssUnion    TaxRegistrationCountryOptionsNLType = "oss_union"
	TaxRegistrationCountryOptionsNLTypeStandard    TaxRegistrationCountryOptionsNLType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsNoType string

// List of values that TaxRegistrationCountryOptionsNoType can take
const (
	TaxRegistrationCountryOptionsNoTypeStandard TaxRegistrationCountryOptionsNoType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsNzType string

// List of values that TaxRegistrationCountryOptionsNzType can take
const (
	TaxRegistrationCountryOptionsNzTypeStandard TaxRegistrationCountryOptionsNzType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsOmType string

// List of values that TaxRegistrationCountryOptionsOmType can take
const (
	TaxRegistrationCountryOptionsOmTypeStandard TaxRegistrationCountryOptionsOmType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsPLStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsPLStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsPLStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsPLStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsPLStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsPLStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsPLType string

// List of values that TaxRegistrationCountryOptionsPLType can take
const (
	TaxRegistrationCountryOptionsPLTypeIoss        TaxRegistrationCountryOptionsPLType = "ioss"
	TaxRegistrationCountryOptionsPLTypeOssNonUnion TaxRegistrationCountryOptionsPLType = "oss_non_union"
	TaxRegistrationCountryOptionsPLTypeOssUnion    TaxRegistrationCountryOptionsPLType = "oss_union"
	TaxRegistrationCountryOptionsPLTypeStandard    TaxRegistrationCountryOptionsPLType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsPTStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsPTStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsPTStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsPTStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsPTStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsPTStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsPTType string

// List of values that TaxRegistrationCountryOptionsPTType can take
const (
	TaxRegistrationCountryOptionsPTTypeIoss        TaxRegistrationCountryOptionsPTType = "ioss"
	TaxRegistrationCountryOptionsPTTypeOssNonUnion TaxRegistrationCountryOptionsPTType = "oss_non_union"
	TaxRegistrationCountryOptionsPTTypeOssUnion    TaxRegistrationCountryOptionsPTType = "oss_union"
	TaxRegistrationCountryOptionsPTTypeStandard    TaxRegistrationCountryOptionsPTType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsROStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsROStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsROStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsROStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsROStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsROStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsROType string

// List of values that TaxRegistrationCountryOptionsROType can take
const (
	TaxRegistrationCountryOptionsROTypeIoss        TaxRegistrationCountryOptionsROType = "ioss"
	TaxRegistrationCountryOptionsROTypeOssNonUnion TaxRegistrationCountryOptionsROType = "oss_non_union"
	TaxRegistrationCountryOptionsROTypeOssUnion    TaxRegistrationCountryOptionsROType = "oss_union"
	TaxRegistrationCountryOptionsROTypeStandard    TaxRegistrationCountryOptionsROType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsSaType string

// List of values that TaxRegistrationCountryOptionsSaType can take
const (
	TaxRegistrationCountryOptionsSaTypeSimplified TaxRegistrationCountryOptionsSaType = "simplified"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsSeStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsSeStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsSeStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsSeStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsSeStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsSeStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsSeType string

// List of values that TaxRegistrationCountryOptionsSeType can take
const (
	TaxRegistrationCountryOptionsSeTypeIoss        TaxRegistrationCountryOptionsSeType = "ioss"
	TaxRegistrationCountryOptionsSeTypeOssNonUnion TaxRegistrationCountryOptionsSeType = "oss_non_union"
	TaxRegistrationCountryOptionsSeTypeOssUnion    TaxRegistrationCountryOptionsSeType = "oss_union"
	TaxRegistrationCountryOptionsSeTypeStandard    TaxRegistrationCountryOptionsSeType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsSgType string

// List of values that TaxRegistrationCountryOptionsSgType can take
const (
	TaxRegistrationCountryOptionsSgTypeStandard TaxRegistrationCountryOptionsSgType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsSiStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsSiStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsSiStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsSiStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsSiStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsSiStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsSiType string

// List of values that TaxRegistrationCountryOptionsSiType can take
const (
	TaxRegistrationCountryOptionsSiTypeIoss        TaxRegistrationCountryOptionsSiType = "ioss"
	TaxRegistrationCountryOptionsSiTypeOssNonUnion TaxRegistrationCountryOptionsSiType = "oss_non_union"
	TaxRegistrationCountryOptionsSiTypeOssUnion    TaxRegistrationCountryOptionsSiType = "oss_union"
	TaxRegistrationCountryOptionsSiTypeStandard    TaxRegistrationCountryOptionsSiType = "standard"
)

// Place of supply scheme used in an EU standard registration.
type TaxRegistrationCountryOptionsSKStandardPlaceOfSupplyScheme string

// List of values that TaxRegistrationCountryOptionsSKStandardPlaceOfSupplyScheme can take
const (
	TaxRegistrationCountryOptionsSKStandardPlaceOfSupplySchemeSmallSeller TaxRegistrationCountryOptionsSKStandardPlaceOfSupplyScheme = "small_seller"
	TaxRegistrationCountryOptionsSKStandardPlaceOfSupplySchemeStandard    TaxRegistrationCountryOptionsSKStandardPlaceOfSupplyScheme = "standard"
)

// Type of registration in an EU country.
type TaxRegistrationCountryOptionsSKType string

// List of values that TaxRegistrationCountryOptionsSKType can take
const (
	TaxRegistrationCountryOptionsSKTypeIoss        TaxRegistrationCountryOptionsSKType = "ioss"
	TaxRegistrationCountryOptionsSKTypeOssNonUnion TaxRegistrationCountryOptionsSKType = "oss_non_union"
	TaxRegistrationCountryOptionsSKTypeOssUnion    TaxRegistrationCountryOptionsSKType = "oss_union"
	TaxRegistrationCountryOptionsSKTypeStandard    TaxRegistrationCountryOptionsSKType = "standard"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsTHType string

// List of values that TaxRegistrationCountryOptionsTHType can take
const (
	TaxRegistrationCountryOptionsTHTypeSimplified TaxRegistrationCountryOptionsTHType = "simplified"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsTRType string

// List of values that TaxRegistrationCountryOptionsTRType can take
const (
	TaxRegistrationCountryOptionsTRTypeSimplified TaxRegistrationCountryOptionsTRType = "simplified"
)

// Type of registration in the US.
type TaxRegistrationCountryOptionsUSType string

// List of values that TaxRegistrationCountryOptionsUSType can take
const (
	TaxRegistrationCountryOptionsUSTypeLocalAmusementTax      TaxRegistrationCountryOptionsUSType = "local_amusement_tax"
	TaxRegistrationCountryOptionsUSTypeLocalLeaseTax          TaxRegistrationCountryOptionsUSType = "local_lease_tax"
	TaxRegistrationCountryOptionsUSTypeStateCommunicationsTax TaxRegistrationCountryOptionsUSType = "state_communications_tax"
	TaxRegistrationCountryOptionsUSTypeStateSalesTax          TaxRegistrationCountryOptionsUSType = "state_sales_tax"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsVnType string

// List of values that TaxRegistrationCountryOptionsVnType can take
const (
	TaxRegistrationCountryOptionsVnTypeSimplified TaxRegistrationCountryOptionsVnType = "simplified"
)

// Type of registration in `country`.
type TaxRegistrationCountryOptionsZaType string

// List of values that TaxRegistrationCountryOptionsZaType can take
const (
	TaxRegistrationCountryOptionsZaTypeStandard TaxRegistrationCountryOptionsZaType = "standard"
)

// The status of the registration. This field is present for convenience and can be deduced from `active_from` and `expires_at`.
type TaxRegistrationStatus string

// List of values that TaxRegistrationStatus can take
const (
	TaxRegistrationStatusActive    TaxRegistrationStatus = "active"
	TaxRegistrationStatusExpired   TaxRegistrationStatus = "expired"
	TaxRegistrationStatusScheduled TaxRegistrationStatus = "scheduled"
)

// Returns a list of Tax Registration objects.
type TaxRegistrationListParams struct {
	ListParams `form:"*"`
	// Specifies which fields in the response should be expanded.
	Expand []*string `form:"expand"`
	// The status of the Tax Registration.
	Status *string `form:"status"`
}

// AddExpand appends a new field to expand.
func (p *TaxRegistrationListParams) AddExpand(f string) {
	p.Expand = append(p.Expand, &f)
}

// Options for the registration in AE.
type TaxRegistrationCountryOptionsAeParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsAtStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in AT.
type TaxRegistrationCountryOptionsAtParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsAtStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in AU.
type TaxRegistrationCountryOptionsAuParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsBeStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in BE.
type TaxRegistrationCountryOptionsBeParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsBeStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsBGStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in BG.
type TaxRegistrationCountryOptionsBGParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsBGStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in BH.
type TaxRegistrationCountryOptionsBhParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the provincial tax registration.
type TaxRegistrationCountryOptionsCaProvinceStandardParams struct {
	// Two-letter CA province code ([ISO 3166-2](https://en.wikipedia.org/wiki/ISO_3166-2)).
	Province *string `form:"province"`
}

// Options for the registration in CA.
type TaxRegistrationCountryOptionsCaParams struct {
	// Options for the provincial tax registration.
	ProvinceStandard *TaxRegistrationCountryOptionsCaProvinceStandardParams `form:"province_standard"`
	// Type of registration to be created in Canada.
	Type *string `form:"type"`
}

// Options for the registration in CH.
type TaxRegistrationCountryOptionsChParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in CL.
type TaxRegistrationCountryOptionsClParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in CO.
type TaxRegistrationCountryOptionsCoParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsCyStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in CY.
type TaxRegistrationCountryOptionsCyParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsCyStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsCzStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in CZ.
type TaxRegistrationCountryOptionsCzParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsCzStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsDEStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in DE.
type TaxRegistrationCountryOptionsDEParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsDEStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsDkStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in DK.
type TaxRegistrationCountryOptionsDkParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsDkStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsEeStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in EE.
type TaxRegistrationCountryOptionsEeParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsEeStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in EG.
type TaxRegistrationCountryOptionsEgParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsESStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in ES.
type TaxRegistrationCountryOptionsESParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsESStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsFIStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in FI.
type TaxRegistrationCountryOptionsFIParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsFIStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsFRStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in FR.
type TaxRegistrationCountryOptionsFRParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsFRStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in GB.
type TaxRegistrationCountryOptionsGBParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in GE.
type TaxRegistrationCountryOptionsGeParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsGrStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in GR.
type TaxRegistrationCountryOptionsGrParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsGrStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsHRStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in HR.
type TaxRegistrationCountryOptionsHRParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsHRStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsHUStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in HU.
type TaxRegistrationCountryOptionsHUParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsHUStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in ID.
type TaxRegistrationCountryOptionsIDParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsIeStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in IE.
type TaxRegistrationCountryOptionsIeParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsIeStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in IS.
type TaxRegistrationCountryOptionsIsParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsITStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in IT.
type TaxRegistrationCountryOptionsITParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsITStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in JP.
type TaxRegistrationCountryOptionsJPParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in KE.
type TaxRegistrationCountryOptionsKeParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in KR.
type TaxRegistrationCountryOptionsKrParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in KZ.
type TaxRegistrationCountryOptionsKzParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsLTStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in LT.
type TaxRegistrationCountryOptionsLTParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsLTStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsLuStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in LU.
type TaxRegistrationCountryOptionsLuParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsLuStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsLVStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in LV.
type TaxRegistrationCountryOptionsLVParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsLVStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsMTStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in MT.
type TaxRegistrationCountryOptionsMTParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsMTStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in MX.
type TaxRegistrationCountryOptionsMXParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in MY.
type TaxRegistrationCountryOptionsMyParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in NG.
type TaxRegistrationCountryOptionsNgParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsNLStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in NL.
type TaxRegistrationCountryOptionsNLParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsNLStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in NO.
type TaxRegistrationCountryOptionsNoParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in NZ.
type TaxRegistrationCountryOptionsNzParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in OM.
type TaxRegistrationCountryOptionsOmParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsPLStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in PL.
type TaxRegistrationCountryOptionsPLParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsPLStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsPTStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in PT.
type TaxRegistrationCountryOptionsPTParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsPTStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsROStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in RO.
type TaxRegistrationCountryOptionsROParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsROStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in SA.
type TaxRegistrationCountryOptionsSaParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsSeStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in SE.
type TaxRegistrationCountryOptionsSeParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsSeStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in SG.
type TaxRegistrationCountryOptionsSgParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsSiStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in SI.
type TaxRegistrationCountryOptionsSiParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsSiStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the standard registration.
type TaxRegistrationCountryOptionsSKStandardParams struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme *string `form:"place_of_supply_scheme"`
}

// Options for the registration in SK.
type TaxRegistrationCountryOptionsSKParams struct {
	// Options for the standard registration.
	Standard *TaxRegistrationCountryOptionsSKStandardParams `form:"standard"`
	// Type of registration to be created in an EU country.
	Type *string `form:"type"`
}

// Options for the registration in TH.
type TaxRegistrationCountryOptionsTHParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in TR.
type TaxRegistrationCountryOptionsTRParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the local amusement tax registration.
type TaxRegistrationCountryOptionsUSLocalAmusementTaxParams struct {
	// A [FIPS code](https://www.census.gov/library/reference/code-lists/ansi.html) representing the local jurisdiction. Supported FIPS codes are: `14000` (Chicago), `06613` (Bloomington), `21696` (East Dundee), `24582` (Evanston), and `68081` (Schiller Park).
	Jurisdiction *string `form:"jurisdiction"`
}

// Options for the local lease tax registration.
type TaxRegistrationCountryOptionsUSLocalLeaseTaxParams struct {
	// A [FIPS code](https://www.census.gov/library/reference/code-lists/ansi.html) representing the local jurisdiction. Supported FIPS codes are: `14000` (Chicago).
	Jurisdiction *string `form:"jurisdiction"`
}

// Options for the registration in US.
type TaxRegistrationCountryOptionsUSParams struct {
	// Options for the local amusement tax registration.
	LocalAmusementTax *TaxRegistrationCountryOptionsUSLocalAmusementTaxParams `form:"local_amusement_tax"`
	// Options for the local lease tax registration.
	LocalLeaseTax *TaxRegistrationCountryOptionsUSLocalLeaseTaxParams `form:"local_lease_tax"`
	// Two-letter US state code ([ISO 3166-2](https://en.wikipedia.org/wiki/ISO_3166-2)).
	State *string `form:"state"`
	// Type of registration to be created in the US.
	Type *string `form:"type"`
}

// Options for the registration in VN.
type TaxRegistrationCountryOptionsVnParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Options for the registration in ZA.
type TaxRegistrationCountryOptionsZaParams struct {
	// Type of registration to be created in `country`.
	Type *string `form:"type"`
}

// Specific options for a registration in the specified `country`.
type TaxRegistrationCountryOptionsParams struct {
	// Options for the registration in AE.
	Ae *TaxRegistrationCountryOptionsAeParams `form:"ae"`
	// Options for the registration in AT.
	At *TaxRegistrationCountryOptionsAtParams `form:"at"`
	// Options for the registration in AU.
	Au *TaxRegistrationCountryOptionsAuParams `form:"au"`
	// Options for the registration in BE.
	Be *TaxRegistrationCountryOptionsBeParams `form:"be"`
	// Options for the registration in BG.
	BG *TaxRegistrationCountryOptionsBGParams `form:"bg"`
	// Options for the registration in BH.
	Bh *TaxRegistrationCountryOptionsBhParams `form:"bh"`
	// Options for the registration in CA.
	Ca *TaxRegistrationCountryOptionsCaParams `form:"ca"`
	// Options for the registration in CH.
	Ch *TaxRegistrationCountryOptionsChParams `form:"ch"`
	// Options for the registration in CL.
	Cl *TaxRegistrationCountryOptionsClParams `form:"cl"`
	// Options for the registration in CO.
	Co *TaxRegistrationCountryOptionsCoParams `form:"co"`
	// Options for the registration in CY.
	Cy *TaxRegistrationCountryOptionsCyParams `form:"cy"`
	// Options for the registration in CZ.
	Cz *TaxRegistrationCountryOptionsCzParams `form:"cz"`
	// Options for the registration in DE.
	DE *TaxRegistrationCountryOptionsDEParams `form:"de"`
	// Options for the registration in DK.
	Dk *TaxRegistrationCountryOptionsDkParams `form:"dk"`
	// Options for the registration in EE.
	Ee *TaxRegistrationCountryOptionsEeParams `form:"ee"`
	// Options for the registration in EG.
	Eg *TaxRegistrationCountryOptionsEgParams `form:"eg"`
	// Options for the registration in ES.
	ES *TaxRegistrationCountryOptionsESParams `form:"es"`
	// Options for the registration in FI.
	FI *TaxRegistrationCountryOptionsFIParams `form:"fi"`
	// Options for the registration in FR.
	FR *TaxRegistrationCountryOptionsFRParams `form:"fr"`
	// Options for the registration in GB.
	GB *TaxRegistrationCountryOptionsGBParams `form:"gb"`
	// Options for the registration in GE.
	Ge *TaxRegistrationCountryOptionsGeParams `form:"ge"`
	// Options for the registration in GR.
	Gr *TaxRegistrationCountryOptionsGrParams `form:"gr"`
	// Options for the registration in HR.
	HR *TaxRegistrationCountryOptionsHRParams `form:"hr"`
	// Options for the registration in HU.
	HU *TaxRegistrationCountryOptionsHUParams `form:"hu"`
	// Options for the registration in ID.
	ID *TaxRegistrationCountryOptionsIDParams `form:"id"`
	// Options for the registration in IE.
	Ie *TaxRegistrationCountryOptionsIeParams `form:"ie"`
	// Options for the registration in IS.
	Is *TaxRegistrationCountryOptionsIsParams `form:"is"`
	// Options for the registration in IT.
	IT *TaxRegistrationCountryOptionsITParams `form:"it"`
	// Options for the registration in JP.
	JP *TaxRegistrationCountryOptionsJPParams `form:"jp"`
	// Options for the registration in KE.
	Ke *TaxRegistrationCountryOptionsKeParams `form:"ke"`
	// Options for the registration in KR.
	Kr *TaxRegistrationCountryOptionsKrParams `form:"kr"`
	// Options for the registration in KZ.
	Kz *TaxRegistrationCountryOptionsKzParams `form:"kz"`
	// Options for the registration in LT.
	LT *TaxRegistrationCountryOptionsLTParams `form:"lt"`
	// Options for the registration in LU.
	Lu *TaxRegistrationCountryOptionsLuParams `form:"lu"`
	// Options for the registration in LV.
	LV *TaxRegistrationCountryOptionsLVParams `form:"lv"`
	// Options for the registration in MT.
	MT *TaxRegistrationCountryOptionsMTParams `form:"mt"`
	// Options for the registration in MX.
	MX *TaxRegistrationCountryOptionsMXParams `form:"mx"`
	// Options for the registration in MY.
	My *TaxRegistrationCountryOptionsMyParams `form:"my"`
	// Options for the registration in NG.
	Ng *TaxRegistrationCountryOptionsNgParams `form:"ng"`
	// Options for the registration in NL.
	NL *TaxRegistrationCountryOptionsNLParams `form:"nl"`
	// Options for the registration in NO.
	No *TaxRegistrationCountryOptionsNoParams `form:"no"`
	// Options for the registration in NZ.
	Nz *TaxRegistrationCountryOptionsNzParams `form:"nz"`
	// Options for the registration in OM.
	Om *TaxRegistrationCountryOptionsOmParams `form:"om"`
	// Options for the registration in PL.
	PL *TaxRegistrationCountryOptionsPLParams `form:"pl"`
	// Options for the registration in PT.
	PT *TaxRegistrationCountryOptionsPTParams `form:"pt"`
	// Options for the registration in RO.
	RO *TaxRegistrationCountryOptionsROParams `form:"ro"`
	// Options for the registration in SA.
	Sa *TaxRegistrationCountryOptionsSaParams `form:"sa"`
	// Options for the registration in SE.
	Se *TaxRegistrationCountryOptionsSeParams `form:"se"`
	// Options for the registration in SG.
	Sg *TaxRegistrationCountryOptionsSgParams `form:"sg"`
	// Options for the registration in SI.
	Si *TaxRegistrationCountryOptionsSiParams `form:"si"`
	// Options for the registration in SK.
	SK *TaxRegistrationCountryOptionsSKParams `form:"sk"`
	// Options for the registration in TH.
	TH *TaxRegistrationCountryOptionsTHParams `form:"th"`
	// Options for the registration in TR.
	TR *TaxRegistrationCountryOptionsTRParams `form:"tr"`
	// Options for the registration in US.
	US *TaxRegistrationCountryOptionsUSParams `form:"us"`
	// Options for the registration in VN.
	Vn *TaxRegistrationCountryOptionsVnParams `form:"vn"`
	// Options for the registration in ZA.
	Za *TaxRegistrationCountryOptionsZaParams `form:"za"`
}

// Creates a new Tax Registration object.
type TaxRegistrationParams struct {
	Params `form:"*"`
	// Time at which the Tax Registration becomes active. It can be either `now` to indicate the current time, or a future timestamp measured in seconds since the Unix epoch.
	ActiveFrom    *int64 `form:"active_from"`
	ActiveFromNow *bool  `form:"-"` // See custom AppendTo
	// Two-letter country code ([ISO 3166-1 alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)).
	Country *string `form:"country"`
	// Specific options for a registration in the specified `country`.
	CountryOptions *TaxRegistrationCountryOptionsParams `form:"country_options"`
	// Specifies which fields in the response should be expanded.
	Expand []*string `form:"expand"`
	// If set, the registration stops being active at this time. If not set, the registration will be active indefinitely. It can be either `now` to indicate the current time, or a timestamp measured in seconds since the Unix epoch.
	ExpiresAt    *int64 `form:"expires_at"`
	ExpiresAtNow *bool  `form:"-"` // See custom AppendTo
}

// AddExpand appends a new field to expand.
func (p *TaxRegistrationParams) AddExpand(f string) {
	p.Expand = append(p.Expand, &f)
}

// AppendTo implements custom encoding logic for TaxRegistrationParams.
func (p *TaxRegistrationParams) AppendTo(body *form.Values, keyParts []string) {
	if BoolValue(p.ActiveFromNow) {
		body.Add(form.FormatKey(append(keyParts, "active_from")), "now")
	}
	if BoolValue(p.ExpiresAtNow) {
		body.Add(form.FormatKey(append(keyParts, "expires_at")), "now")
	}
}

type TaxRegistrationCountryOptionsAe struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsAeType `json:"type"`
}
type TaxRegistrationCountryOptionsAtStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsAtStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsAt struct {
	Standard *TaxRegistrationCountryOptionsAtStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsAtType `json:"type"`
}
type TaxRegistrationCountryOptionsAu struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsAuType `json:"type"`
}
type TaxRegistrationCountryOptionsBeStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsBeStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsBe struct {
	Standard *TaxRegistrationCountryOptionsBeStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsBeType `json:"type"`
}
type TaxRegistrationCountryOptionsBGStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsBGStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsBG struct {
	Standard *TaxRegistrationCountryOptionsBGStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsBGType `json:"type"`
}
type TaxRegistrationCountryOptionsBh struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsBhType `json:"type"`
}
type TaxRegistrationCountryOptionsCaProvinceStandard struct {
	// Two-letter CA province code ([ISO 3166-2](https://en.wikipedia.org/wiki/ISO_3166-2)).
	Province string `json:"province"`
}
type TaxRegistrationCountryOptionsCa struct {
	ProvinceStandard *TaxRegistrationCountryOptionsCaProvinceStandard `json:"province_standard"`
	// Type of registration in Canada.
	Type TaxRegistrationCountryOptionsCaType `json:"type"`
}
type TaxRegistrationCountryOptionsCh struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsChType `json:"type"`
}
type TaxRegistrationCountryOptionsCl struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsClType `json:"type"`
}
type TaxRegistrationCountryOptionsCo struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsCoType `json:"type"`
}
type TaxRegistrationCountryOptionsCyStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsCyStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsCy struct {
	Standard *TaxRegistrationCountryOptionsCyStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsCyType `json:"type"`
}
type TaxRegistrationCountryOptionsCzStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsCzStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsCz struct {
	Standard *TaxRegistrationCountryOptionsCzStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsCzType `json:"type"`
}
type TaxRegistrationCountryOptionsDEStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsDEStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsDE struct {
	Standard *TaxRegistrationCountryOptionsDEStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsDEType `json:"type"`
}
type TaxRegistrationCountryOptionsDkStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsDkStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsDk struct {
	Standard *TaxRegistrationCountryOptionsDkStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsDkType `json:"type"`
}
type TaxRegistrationCountryOptionsEeStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsEeStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsEe struct {
	Standard *TaxRegistrationCountryOptionsEeStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsEeType `json:"type"`
}
type TaxRegistrationCountryOptionsEg struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsEgType `json:"type"`
}
type TaxRegistrationCountryOptionsESStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsESStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsES struct {
	Standard *TaxRegistrationCountryOptionsESStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsESType `json:"type"`
}
type TaxRegistrationCountryOptionsFIStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsFIStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsFI struct {
	Standard *TaxRegistrationCountryOptionsFIStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsFIType `json:"type"`
}
type TaxRegistrationCountryOptionsFRStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsFRStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsFR struct {
	Standard *TaxRegistrationCountryOptionsFRStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsFRType `json:"type"`
}
type TaxRegistrationCountryOptionsGB struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsGBType `json:"type"`
}
type TaxRegistrationCountryOptionsGe struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsGeType `json:"type"`
}
type TaxRegistrationCountryOptionsGrStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsGrStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsGr struct {
	Standard *TaxRegistrationCountryOptionsGrStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsGrType `json:"type"`
}
type TaxRegistrationCountryOptionsHRStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsHRStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsHR struct {
	Standard *TaxRegistrationCountryOptionsHRStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsHRType `json:"type"`
}
type TaxRegistrationCountryOptionsHUStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsHUStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsHU struct {
	Standard *TaxRegistrationCountryOptionsHUStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsHUType `json:"type"`
}
type TaxRegistrationCountryOptionsID struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsIDType `json:"type"`
}
type TaxRegistrationCountryOptionsIeStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsIeStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsIe struct {
	Standard *TaxRegistrationCountryOptionsIeStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsIeType `json:"type"`
}
type TaxRegistrationCountryOptionsIs struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsIsType `json:"type"`
}
type TaxRegistrationCountryOptionsITStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsITStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsIT struct {
	Standard *TaxRegistrationCountryOptionsITStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsITType `json:"type"`
}
type TaxRegistrationCountryOptionsJP struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsJPType `json:"type"`
}
type TaxRegistrationCountryOptionsKe struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsKeType `json:"type"`
}
type TaxRegistrationCountryOptionsKr struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsKrType `json:"type"`
}
type TaxRegistrationCountryOptionsKz struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsKzType `json:"type"`
}
type TaxRegistrationCountryOptionsLTStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsLTStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsLT struct {
	Standard *TaxRegistrationCountryOptionsLTStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsLTType `json:"type"`
}
type TaxRegistrationCountryOptionsLuStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsLuStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsLu struct {
	Standard *TaxRegistrationCountryOptionsLuStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsLuType `json:"type"`
}
type TaxRegistrationCountryOptionsLVStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsLVStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsLV struct {
	Standard *TaxRegistrationCountryOptionsLVStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsLVType `json:"type"`
}
type TaxRegistrationCountryOptionsMTStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsMTStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsMT struct {
	Standard *TaxRegistrationCountryOptionsMTStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsMTType `json:"type"`
}
type TaxRegistrationCountryOptionsMX struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsMXType `json:"type"`
}
type TaxRegistrationCountryOptionsMy struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsMyType `json:"type"`
}
type TaxRegistrationCountryOptionsNg struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsNgType `json:"type"`
}
type TaxRegistrationCountryOptionsNLStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsNLStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsNL struct {
	Standard *TaxRegistrationCountryOptionsNLStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsNLType `json:"type"`
}
type TaxRegistrationCountryOptionsNo struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsNoType `json:"type"`
}
type TaxRegistrationCountryOptionsNz struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsNzType `json:"type"`
}
type TaxRegistrationCountryOptionsOm struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsOmType `json:"type"`
}
type TaxRegistrationCountryOptionsPLStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsPLStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsPL struct {
	Standard *TaxRegistrationCountryOptionsPLStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsPLType `json:"type"`
}
type TaxRegistrationCountryOptionsPTStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsPTStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsPT struct {
	Standard *TaxRegistrationCountryOptionsPTStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsPTType `json:"type"`
}
type TaxRegistrationCountryOptionsROStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsROStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsRO struct {
	Standard *TaxRegistrationCountryOptionsROStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsROType `json:"type"`
}
type TaxRegistrationCountryOptionsSa struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsSaType `json:"type"`
}
type TaxRegistrationCountryOptionsSeStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsSeStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsSe struct {
	Standard *TaxRegistrationCountryOptionsSeStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsSeType `json:"type"`
}
type TaxRegistrationCountryOptionsSg struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsSgType `json:"type"`
}
type TaxRegistrationCountryOptionsSiStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsSiStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsSi struct {
	Standard *TaxRegistrationCountryOptionsSiStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsSiType `json:"type"`
}
type TaxRegistrationCountryOptionsSKStandard struct {
	// Place of supply scheme used in an EU standard registration.
	PlaceOfSupplyScheme TaxRegistrationCountryOptionsSKStandardPlaceOfSupplyScheme `json:"place_of_supply_scheme"`
}
type TaxRegistrationCountryOptionsSK struct {
	Standard *TaxRegistrationCountryOptionsSKStandard `json:"standard"`
	// Type of registration in an EU country.
	Type TaxRegistrationCountryOptionsSKType `json:"type"`
}
type TaxRegistrationCountryOptionsTH struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsTHType `json:"type"`
}
type TaxRegistrationCountryOptionsTR struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsTRType `json:"type"`
}
type TaxRegistrationCountryOptionsUSLocalAmusementTax struct {
	// A [FIPS code](https://www.census.gov/library/reference/code-lists/ansi.html) representing the local jurisdiction.
	Jurisdiction string `json:"jurisdiction"`
}
type TaxRegistrationCountryOptionsUSLocalLeaseTax struct {
	// A [FIPS code](https://www.census.gov/library/reference/code-lists/ansi.html) representing the local jurisdiction.
	Jurisdiction string `json:"jurisdiction"`
}
type TaxRegistrationCountryOptionsUS struct {
	LocalAmusementTax *TaxRegistrationCountryOptionsUSLocalAmusementTax `json:"local_amusement_tax"`
	LocalLeaseTax     *TaxRegistrationCountryOptionsUSLocalLeaseTax     `json:"local_lease_tax"`
	// Two-letter US state code ([ISO 3166-2](https://en.wikipedia.org/wiki/ISO_3166-2)).
	State string `json:"state"`
	// Type of registration in the US.
	Type TaxRegistrationCountryOptionsUSType `json:"type"`
}
type TaxRegistrationCountryOptionsVn struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsVnType `json:"type"`
}
type TaxRegistrationCountryOptionsZa struct {
	// Type of registration in `country`.
	Type TaxRegistrationCountryOptionsZaType `json:"type"`
}
type TaxRegistrationCountryOptions struct {
	Ae *TaxRegistrationCountryOptionsAe `json:"ae"`
	At *TaxRegistrationCountryOptionsAt `json:"at"`
	Au *TaxRegistrationCountryOptionsAu `json:"au"`
	Be *TaxRegistrationCountryOptionsBe `json:"be"`
	BG *TaxRegistrationCountryOptionsBG `json:"bg"`
	Bh *TaxRegistrationCountryOptionsBh `json:"bh"`
	Ca *TaxRegistrationCountryOptionsCa `json:"ca"`
	Ch *TaxRegistrationCountryOptionsCh `json:"ch"`
	Cl *TaxRegistrationCountryOptionsCl `json:"cl"`
	Co *TaxRegistrationCountryOptionsCo `json:"co"`
	Cy *TaxRegistrationCountryOptionsCy `json:"cy"`
	Cz *TaxRegistrationCountryOptionsCz `json:"cz"`
	DE *TaxRegistrationCountryOptionsDE `json:"de"`
	Dk *TaxRegistrationCountryOptionsDk `json:"dk"`
	Ee *TaxRegistrationCountryOptionsEe `json:"ee"`
	Eg *TaxRegistrationCountryOptionsEg `json:"eg"`
	ES *TaxRegistrationCountryOptionsES `json:"es"`
	FI *TaxRegistrationCountryOptionsFI `json:"fi"`
	FR *TaxRegistrationCountryOptionsFR `json:"fr"`
	GB *TaxRegistrationCountryOptionsGB `json:"gb"`
	Ge *TaxRegistrationCountryOptionsGe `json:"ge"`
	Gr *TaxRegistrationCountryOptionsGr `json:"gr"`
	HR *TaxRegistrationCountryOptionsHR `json:"hr"`
	HU *TaxRegistrationCountryOptionsHU `json:"hu"`
	ID *TaxRegistrationCountryOptionsID `json:"id"`
	Ie *TaxRegistrationCountryOptionsIe `json:"ie"`
	Is *TaxRegistrationCountryOptionsIs `json:"is"`
	IT *TaxRegistrationCountryOptionsIT `json:"it"`
	JP *TaxRegistrationCountryOptionsJP `json:"jp"`
	Ke *TaxRegistrationCountryOptionsKe `json:"ke"`
	Kr *TaxRegistrationCountryOptionsKr `json:"kr"`
	Kz *TaxRegistrationCountryOptionsKz `json:"kz"`
	LT *TaxRegistrationCountryOptionsLT `json:"lt"`
	Lu *TaxRegistrationCountryOptionsLu `json:"lu"`
	LV *TaxRegistrationCountryOptionsLV `json:"lv"`
	MT *TaxRegistrationCountryOptionsMT `json:"mt"`
	MX *TaxRegistrationCountryOptionsMX `json:"mx"`
	My *TaxRegistrationCountryOptionsMy `json:"my"`
	Ng *TaxRegistrationCountryOptionsNg `json:"ng"`
	NL *TaxRegistrationCountryOptionsNL `json:"nl"`
	No *TaxRegistrationCountryOptionsNo `json:"no"`
	Nz *TaxRegistrationCountryOptionsNz `json:"nz"`
	Om *TaxRegistrationCountryOptionsOm `json:"om"`
	PL *TaxRegistrationCountryOptionsPL `json:"pl"`
	PT *TaxRegistrationCountryOptionsPT `json:"pt"`
	RO *TaxRegistrationCountryOptionsRO `json:"ro"`
	Sa *TaxRegistrationCountryOptionsSa `json:"sa"`
	Se *TaxRegistrationCountryOptionsSe `json:"se"`
	Sg *TaxRegistrationCountryOptionsSg `json:"sg"`
	Si *TaxRegistrationCountryOptionsSi `json:"si"`
	SK *TaxRegistrationCountryOptionsSK `json:"sk"`
	TH *TaxRegistrationCountryOptionsTH `json:"th"`
	TR *TaxRegistrationCountryOptionsTR `json:"tr"`
	US *TaxRegistrationCountryOptionsUS `json:"us"`
	Vn *TaxRegistrationCountryOptionsVn `json:"vn"`
	Za *TaxRegistrationCountryOptionsZa `json:"za"`
}

// A Tax `Registration` lets us know that your business is registered to collect tax on payments within a region, enabling you to [automatically collect tax](https://stripe.com/docs/tax).
//
// Stripe doesn't register on your behalf with the relevant authorities when you create a Tax `Registration` object. For more information on how to register to collect tax, see [our guide](https://stripe.com/docs/tax/registering).
//
// Related guide: [Using the Registrations API](https://stripe.com/docs/tax/registrations-api)
type TaxRegistration struct {
	APIResource
	// Time at which the registration becomes active. Measured in seconds since the Unix epoch.
	ActiveFrom int64 `json:"active_from"`
	// Two-letter country code ([ISO 3166-1 alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)).
	Country        string                         `json:"country"`
	CountryOptions *TaxRegistrationCountryOptions `json:"country_options"`
	// Time at which the object was created. Measured in seconds since the Unix epoch.
	Created int64 `json:"created"`
	// If set, the registration stops being active at this time. If not set, the registration will be active indefinitely. Measured in seconds since the Unix epoch.
	ExpiresAt int64 `json:"expires_at"`
	// Unique identifier for the object.
	ID string `json:"id"`
	// Has the value `true` if the object exists in live mode or the value `false` if the object exists in test mode.
	Livemode bool `json:"livemode"`
	// String representing the object's type. Objects of the same type share the same value.
	Object string `json:"object"`
	// The status of the registration. This field is present for convenience and can be deduced from `active_from` and `expires_at`.
	Status TaxRegistrationStatus `json:"status"`
}

// TaxRegistrationList is a list of Registrations as retrieved from a list endpoint.
type TaxRegistrationList struct {
	APIResource
	ListMeta
	Data []*TaxRegistration `json:"data"`
}
